/* Runge Kutta Method */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NRK     100

/* Fourth Order Runge Kutta Method */

double Runge_Kutta_4(double a, double b);
double YFunc(double x, double y);

double Runge_Kutta_4(double a, double b)
{
  double k1, k2, k3, k4, h, xp;
  double xv, yv, Yf = 0.0, x = a; 
  int np = 0;

  while(x < b) {
    yv = Yf;
    xv = x;

    k1 = h * YFunc(xv, yv);

    yv = Yf + k1 / 2.0;
    xv = x + h / 2.0;

    k2 = h * YFunc(xv, yv);

    yv = Yf + k2 / 2.0;

    k3 = h * YFunc(xv, yv);

    yv = Yf + k3 / 2.0;
    xv = x + h;

    k4 = h * YFunc(xv, yv);

    Yf = Yf + (k1 + 2.0 *(k2 + k3) + k4) / 6.0;   
    
    x  = x + h;
    np = np + 1;
  }

  return Yf;
}     

double YFunc(double x, double y)
{
  double func;

  func = log(1.0 + x * x) / x;

  return func;
}
