/*
 *.
 *  This file is part of XForms package
 *  Copyright (c) 1995-1997  T.C. Zhao and Mark Overmars
 *  All rights reserved.
 *.
 *
 *  A sample implementation of OpenGL/Mesa canvas class.
 *
 *  For typical objects, ob->spec is the place for the
 *  object specific info. For OpenGL canvas, however, the
 *  ob->spec is already used by the generic canvas. We use
 *  ob->c_vdata to hang the OpenGL specific stuff.
 *
 *   See ../DEMOS/gl.c for an example use of glcanvas.
 *   See ../DEMOS/glwin.c for an example use of fl_glwinopen
 *
 */

#include <GL/glx.h>
#include <GL/gl.h>
#include <forms.h> 

/* OpenGL canvases */

FL_EXPORT FL_OBJECT *fl_add_glcanvas(int type, FL_Coord x, FL_Coord y, 
				     FL_Coord w, FL_Coord h, const char *label);

/* Modify the global defaults */

FL_EXPORT void fl_set_glcanvas_defaults(const int *config);

FL_EXPORT void fl_get_glcanvas_defaults(int *config);

/* Modify the default configuration of a particular canvas */

FL_EXPORT void fl_set_glcanvas_attributes(FL_OBJECT *ob, const int *config);

FL_EXPORT void fl_get_glcanvas_attributes(FL_OBJECT *ob, int *attributes);

FL_EXPORT void fl_set_glcanvas_direct(FL_OBJECT *ob, int direct);

FL_EXPORT void fl_activate_glcanvas(FL_OBJECT *ob);

// FL_EXPORT GLXContext fl_get_glcanvas_context(FL_OBJECT *ob);

FL_EXPORT XVisualInfo *fl_get_glcanvas_xvisualinfo(FL_OBJECT *ob);

/* Interface routines */

FL_EXPORT FL_OBJECT *fl_create_glcanvas(int type, FL_Coord x, FL_Coord y, 
					FL_Coord w, FL_Coord h, 
					const char *label);

/*************************************************************
 * Open a top-level OpenGL window.
 *
 * fl_winset won't work for switching OpenGL windows.
 * Use glXMakeCurrent
 ************************************************************/

FL_EXPORT Window fl_glwincreate(int *config, GLXContext *context, int w, int h);

FL_EXPORT Window fl_glwinopen(int *config, GLXContext *context, int w, int h);












