#include <stdlib.h>
#include <string.h>

// #include <forms.h>


#include "forms.h"
#include "glform.h"
#include "glxf.h"

/*

static int border0 = FL_NOBORDER; 
static int border  = FL_TRANSIENT;

**/

static int border2 = FL_FULLBORDER;

// char *fname = "m45.jpg";

char *fname;

FD_GLcp *Panel;
FD_Help *Help;
FD_Oposition *Oposition;
FD_Optimum *Optimum;
FD_Parametres *Parametres;
FD_track *Track;

/* callbacks and freeobj handles for form GLcp */

void cb_source_pos(FL_OBJECT *ob, long data)
{
  FD_GLcp *main_form = (FD_GLcp *)data;
  
  if(ob == (main_form->x_pos)) {
    fl_set_positioner_xvalue(main_form->source_pos,
			     fl_get_counter_value(ob));
  } else if(ob == (main_form->y_pos)) {
    fl_set_positioner_yvalue(main_form->source_pos,
			     fl_get_counter_value(ob));
  } else if (ob == (main_form->source_pos)) {
    fl_set_counter_value(main_form->x_pos,
			 fl_get_positioner_xvalue(ob));
    fl_set_counter_value(main_form->y_pos,
			 fl_get_positioner_yvalue(ob));
  }

  source_position.x = fl_get_counter_value(main_form->x_pos);
  source_position.y = fl_get_counter_value(main_form->y_pos);

  Y[0] = source_position.x;
  Y[1] = source_position.y;

  /* Refresh */

  handle_expose(0, 0); 
} 

void cb_parameters(FL_OBJECT *ob, long parameter)
{
  parms[parameter] = fl_get_slider_value(ob);
  
  /* Refresh */
  
  handle_expose(0, 0);
}

void cb_presicion(FL_OBJECT *ob, long data)
{
  precision = (int) fl_get_counter_value(ob);

  /* Refresh */

  handle_expose(0, 0); 
}

void cb_switches(FL_OBJECT *ob, long which_switch)
{
  /*
    
  if(fl_get_button(ob)) {
    if(source_figure == F_IMAGE) {
      printf("Press the Image button after you had chosen the image file. \n");
      printf("Choose the image file with the Image File button. \n");
      printf("The program crashes if you press the Image button after \n");
      printf("you have chosen the source with the Source Menu. \n");
    } 
  }

  **/
  
  if(fl_get_button(ob)) {
    switches |= which_switch;
  } else {
    switches &= ~which_switch;
  }
  
  /* Refresh */

  handle_expose(0, 0); 
}

void cb_cc_caustic(FL_OBJECT *ob, long which_cocc)
{
  /*

  critical();
  caustic();

  */

  printf("Not yet implemented \n");
}

void cb_light_curve(FL_OBJECT *ob, long which_curve)
{
  printf("Not yet implemented \n");
}

void cb_time_delay(FL_OBJECT *ob, long which_td)
{
  extern void draw_contour_td();

  draw_contour_td();
}

void load_file(FL_OBJECT *ob, long arg)
{
  image_switch = TRUE;

  fname = (char *) fl_show_file_selector("File To Load", "", "*", "");

  // fl_activate_object(GLcp->images);
}

void cb_sources(FL_OBJECT *ob, long data)
{
  source_figure = fl_get_menu(ob);

  switch(source_figure) {
  case F_MODEL:
    
    break;
  case F_FULL_CIRCLE:
    
    break;
  case F_RINGS:

    break;
  case F_IMAGE:

    break;
  default:
    break;
  }
}

void cb_images(FL_OBJECT *ob, long data)
{
  source_figure = fl_get_menu(ob);

  switch(source_figure) {
  case F_MODEL:
    
    break;
  case F_FULL_CIRCLE:
    
    break;
  case F_RINGS:

    break;
  case F_IMAGE:

    break;
  default:
    break;
  }
}

void cb_save(FL_OBJECT *ob, long data)
{
  current_save = fl_get_menu(ob);

  switch(current_save) {
  case 1:
    system("xv &"); 
    break;
  case 2:
    system("display"); 
    break;
  case 3:
    system("/usr/local/bin/gimp &"); 
    break;
  case 4:
    system("snapshot &"); 
    break;
  default:
    break;
  }
}

void cb_exit(FL_OBJECT *ob, long data)
{  
 fl_finish();
 exit(0); 
}

void cb_model(FL_OBJECT *ob, long data)
{
  FD_GLcp *main_form = (FD_GLcp *) data;

  current_model = fl_get_choice(ob) - 1; 

  fl_hide_object(main_form->p_E);
  fl_hide_object(main_form->p_theta);
  fl_hide_object(main_form->p_gamma);
  fl_hide_object(main_form->p_sigma);
  fl_hide_object(main_form->p_phi);
  fl_hide_object(main_form->p_R);
  fl_hide_object(main_form->p_C);  
  fl_hide_object(main_form->p_xt);  
  fl_hide_object(main_form->p_doublelens_model);
  fl_hide_object(main_form->p_rotationlens_model);
  fl_hide_object(main_form->p_quadrupole_model);
  fl_hide_object(main_form->p_elliptical_model);
  fl_hide_object(main_form->p_kappa);
  fl_hide_object(main_form->p_kappa2);
  fl_hide_object(main_form->p_alpha);  
  fl_hide_object(main_form->p_alpha2); 
  fl_hide_object(main_form->p_alpha3); 
  fl_hide_object(main_form->p_epsilon);
  fl_hide_object(main_form->p_epsilon2);
  fl_hide_object(main_form->p_epsilon3);
  fl_hide_object(main_form->p_exp);
  fl_hide_object(main_form->p_ko);
  fl_hide_object(main_form->p_uniform_ring);    
  fl_hide_object(main_form->p_elliptical_kk);    

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    break;    
  case M_SECOND:    
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_ko);
    break;    
  case M_SING_ISOT_SPHERE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_exp);
    break;
  case M_DE_VAUCOULEUR:
  case M_KING: 
  case M_HUBBLE:
  case M_N_F_W:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    break;
  case M_SPIRAL:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_alpha2);                     
    break;    
  case M_TRUNC_KING:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);                     
    fl_show_object(main_form->p_kappa2);
    break;    
  case M_NSING_ISOT_SPHERE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);                     
    fl_show_object(main_form->p_kappa);
    break;
  case M_TRANSP_SPHERE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);                     
    break;
  case M_ELLIPTICAL:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);        
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_elliptical_model);
    break;            
  case M_MULTIPOLE:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);        
    fl_show_object(main_form->p_quadrupole_model);
    break;
  case M_ROTATION_LENS:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);        
    fl_show_object(main_form->p_rotationlens_model);
    break;
  case M_DOUBLE_LENS:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);    
    fl_show_object(main_form->p_doublelens_model);    
    break;    
  case M_UNIFORM_RING:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_uniform_ring);    
    break;
  case M_ELL_SIS_KK:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_epsilon3);
    break;
  case M_ELL_KING:
  case M_ELL_HUBBLE:  
  case M_ELL_NIS:
  case M_ELL_PLUMMER:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_epsilon2);
    break;
  case M_ELL_KK:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_elliptical_kk);    
    break;
  case M_BARKANA:
    fl_show_object(main_form->p_E);
    fl_show_object(main_form->p_theta);
    fl_show_object(main_form->p_gamma);
    fl_show_object(main_form->p_sigma);
    fl_show_object(main_form->p_phi);
    fl_show_object(main_form->p_R);
    fl_show_object(main_form->p_C);        
    fl_show_object(main_form->p_kappa);
    fl_show_object(main_form->p_alpha3); 
    fl_show_object(main_form->p_epsilon2);                    
    break;
  default:
    break;
  }

  /* Refresh */

  handle_expose(0, 0); 
}

void cb_source(FL_OBJECT *ob, long data)
{
  source_figure = fl_get_choice(ob) - 1;

  /* Refresh */

  handle_expose(0, 0); 
}

void image_win(FL_OBJECT *ob, long data) 
{  
  if(fl_get_button(ob)) {
    fl_winshow(GLwin);
  } else {
    fl_winhide(GLwin);
  }
}

void model_params(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s1[10],  s2[10],  s3[10],  s4[10],  s5[10],  s6[10],  s7[10],  s8[10];
  char s9[10],  s10[10], s11[10], s12[10], s13[10], s14[10], s15[10], s16[10];
  char s17[10], s18[10], s19[10], s20[10], s21[10], s22[10], s23[10], s24[10];
  char s25[10], s26[10], s27[10], s28[10], s29[10], s30[10], s31[10], s32[10];
  char s33[10], s34[10], s35[10], s36[10], s37[10], s38[10], s39[10], s40[10];
  
  Parametres = create_form_Parametres();

  if(fl_mouse_button()) {
    //                             FL_PLACE_MOUSE|FL_FREE_SIZE,
    
    fl_prepare_form_window(Parametres->Parameters, FL_PLACE_GEOMETRY, 
			   border2, "Parametres Window");
    
    fl_show_form_window(Parametres->Parameters);
  }
  
  sprintf(s1, "%g", Y[0]);
  fl_set_input(Parametres->input_x, s1);  
  
  sprintf(s2, "%g", Y[1]);
  fl_set_input(Parametres->input_y, s2);  
  
  sprintf(s3, "%g", parms[P_E]);
  fl_set_input(Parametres->input_E, s3);  
  
  sprintf(s4, "%g", parms[P_THETA]);
  fl_set_input(Parametres->input_theta, s4);  
  
  sprintf(s5, "%g", parms[P_GAMMA]);
  fl_set_input(Parametres->input_gamma, s5);  
  
  sprintf(s6, "%g", parms[P_SIGMA]);
  fl_set_input(Parametres->input_sigma, s6);  
  
  sprintf(s7, "%g", parms[P_PHI]);
  fl_set_input(Parametres->input_phi, s7);  
  
  sprintf(s8, "%g", parms[P_KAPPA]);
  fl_set_input(Parametres->input_kappa, s8);  
  
  sprintf(s9, "%g", parms[P_EPSILON]);
  fl_set_input(Parametres->input_epsilon, s9);
  
  sprintf(s10, "%g", parms[P_C]);
  fl_set_input(Parametres->input_C, s10);  
  
  sprintf(s11, "%g", parms[P_X_1]);
  fl_set_input(Parametres->input_x1, s11);  
  
  sprintf(s12, "%g", parms[P_Y_1]);
  fl_set_input(Parametres->input_y1, s12);  
  
  sprintf(s13, "%g", parms[P_X_1]);
  fl_set_input(Parametres->input_x2, s13);  
  
  sprintf(s14, "%g", parms[P_Y_2]);
  fl_set_input(Parametres->input_y2, s14);  
  
  sprintf(s15, "%g", parms[P_M_1]);
  fl_set_input(Parametres->input_m1, s15);  
  
  sprintf(s16, "%g", parms[P_M_2]);
  fl_set_input(Parametres->input_m2, s16);  
  
  sprintf(s17, "%g", parms[P_BETA]);
  fl_set_input(Parametres->input_beta, s17);  
  
  sprintf(s18, "%g", parms[P_GAMMA2]);
  fl_set_input(Parametres->input_gamma2, s18);  
    
  sprintf(s19, "%g", parms[P_SIGMA2]);
  fl_set_input(Parametres->input_sigma2, s19);  
  
  sprintf(s20, "%g", parms[P_PHI2]);
  fl_set_input(Parametres->input_phi2, s20);

  sprintf(s21, "%g", parms[P_SX]);
  fl_set_input(Parametres->input_sx, s21);  
  
  sprintf(s22, "%g", parms[P_SY]);
  fl_set_input(Parametres->input_sy, s22);  

  sprintf(s23, "%g", parms[P_ALPHA]);
  fl_set_input(Parametres->input_alpha, s23);  
  
  sprintf(s24, "%g", parms[P_ALPHA2]);
  fl_set_input(Parametres->input_alpha2, s24);  
  
  sprintf(s25, "%g", parms[P_ALPHA3]);  
  fl_set_input(Parametres->input_alpha3, s25);
  
  sprintf(s26, "%g", parms[P_EXP]);
  fl_set_input(Parametres->input_exp, s26);  
  
  sprintf(s27, "%g", parms[P_KAPPA2]);
  fl_set_input(Parametres->input_kappa2, s27);  
  
  sprintf(s28, "%g", parms[P_Ri]);
  fl_set_input(Parametres->input_ri, s28);  
  
  sprintf(s29, "%g", parms[P_Ro]);
  fl_set_input(Parametres->input_ro, s29);  

  sprintf(s30, "%g", parms[P_Ko]);
  fl_set_input(Parametres->input_ko, s30);    

  sprintf(s31, "%g", parms[P_KAPPA0]);
  fl_set_input(Parametres->input_kappa0, s31);  

  sprintf(s32, "%g", parms[P_DX_QP]);
  fl_set_input(Parametres->input_dx, s32);  

  sprintf(s33, "%g", parms[P_DY_QP]);
  fl_set_input(Parametres->input_dy, s33);  
  
  sprintf(s34, "%g", parms[P_QXX]);
  fl_set_input(Parametres->input_qxx, s34);  
  
  sprintf(s35, "%g", parms[P_QXY]);
  fl_set_input(Parametres->input_qxy, s35);  
  
  sprintf(s36, "%g", parms[P_QYY]);
  fl_set_input(Parametres->input_qyy, s36);  

  sprintf(s37, "%g", parms[P_THETA_INC]);
  fl_set_input(Parametres->input_thetai, s37);  
  
  sprintf(s38, "%g", parms[P_Q3]);
  fl_set_input(Parametres->input_q3, s38);  
  
  sprintf(s39, "%g", parms[P_EPSILON2]);
  fl_set_input(Parametres->input_epsilon2, s39);  
  
  sprintf(s40, "%g", parms[P_EPSILON3]);
  fl_set_input(Parametres->input_epsilon3, s40);  
  
  //    fl_deactivate_object(GLcp->model_ps);
  
  /*  if(fl_get_button(ob)) { 
        fl_show_form(Parametres->Parameters, FL_PLACE_MOUSE|FL_FREE_SIZE,
                     border2, "Parametres Window"); */

  /*
    
  if(fl_mouse_button()) {
    fl_prepare_form_window(Parametres->Parameters,
                           FL_PLACE_MOUSE|FL_FREE_SIZE,
                           border2, "Parametres Window");

    fl_show_form_window(Parametres->Parameters);
  }

  **/

  fl_deactivate_object(GLcp->model_ps);

  /* Refresh */     

  /* handle_expose(0, 0); */
  
  glXSwapBuffers(fl_display, GLwin);
}

void set_par(FL_OBJECT *ob, long data)
{
  Y[0]               = atof(fl_get_input(Parametres->input_x));  
  Y[1]               = atof(fl_get_input(Parametres->input_y));    
  parms[P_E]         = atof(fl_get_input(Parametres->input_E));
  parms[P_THETA]     = atof(fl_get_input(Parametres->input_theta));  
  parms[P_GAMMA]     = atof(fl_get_input(Parametres->input_gamma));
  parms[P_SIGMA]     = atof(fl_get_input(Parametres->input_sigma));
  parms[P_PHI]       = atof(fl_get_input(Parametres->input_phi));  
  parms[P_GAMMA2]    = atof(fl_get_input(Parametres->input_gamma2));
  parms[P_SIGMA2]    = atof(fl_get_input(Parametres->input_sigma2));
  parms[P_PHI2]      = atof(fl_get_input(Parametres->input_phi2));
  parms[P_ALPHA]     = atof(fl_get_input(Parametres->input_alpha));
  parms[P_ALPHA2]    = atof(fl_get_input(Parametres->input_alpha2));  
  parms[P_KAPPA]     = atof(fl_get_input(Parametres->input_kappa));
  parms[P_KAPPA0]    = atof(fl_get_input(Parametres->input_kappa0));
  parms[P_KAPPA2]    = atof(fl_get_input(Parametres->input_kappa2));
  parms[P_EPSILON]   = atof(fl_get_input(Parametres->input_epsilon));
  parms[P_EPSILON2]  = atof(fl_get_input(Parametres->input_epsilon2));
  parms[P_EPSILON3]  = atof(fl_get_input(Parametres->input_epsilon3));
  parms[P_BETA]      = atof(fl_get_input(Parametres->input_beta));
  parms[P_C]         = atof(fl_get_input(Parametres->input_C));
  parms[P_Ri]        = atof(fl_get_input(Parametres->input_ri));
  parms[P_Ro]        = atof(fl_get_input(Parametres->input_ro));
  parms[P_X_1]       = atof(fl_get_input(Parametres->input_x1));
  parms[P_Y_1]       = atof(fl_get_input(Parametres->input_y1));
  parms[P_M_1]       = atof(fl_get_input(Parametres->input_m1));
  parms[P_X_2]       = atof(fl_get_input(Parametres->input_x2));
  parms[P_Y_2]       = atof(fl_get_input(Parametres->input_y2));
  parms[P_M_2]       = atof(fl_get_input(Parametres->input_m2));
  parms[P_DX_QP]     = atof(fl_get_input(Parametres->input_dx));
  parms[P_DY_QP]     = atof(fl_get_input(Parametres->input_dy));
  parms[P_QXX]       = atof(fl_get_input(Parametres->input_qxx));
  parms[P_QXY]       = atof(fl_get_input(Parametres->input_qxy));
  parms[P_QYY]       = atof(fl_get_input(Parametres->input_qyy));
  parms[P_SX]        = atof(fl_get_input(Parametres->input_sx));
  parms[P_SY]        = atof(fl_get_input(Parametres->input_sy));
  parms[P_EXP]       = atof(fl_get_input(Parametres->input_exp));
  parms[P_THETA_INC] = atof(fl_get_input(Parametres->input_thetai));
  parms[P_Q3]        = atof(fl_get_input(Parametres->input_q3));

  fl_set_positioner_xvalue(GLcp->source_pos, Y[0]);
  fl_set_positioner_yvalue(GLcp->source_pos, Y[1]);
  
  fl_set_counter_value(GLcp->x_pos, Y[0]);
  fl_set_counter_value(GLcp->y_pos, Y[1]);
  
  fl_set_slider_value(GLcp->p_E, parms[P_E]);
  fl_set_slider_value(GLcp->p_theta, parms[P_THETA]); 
  fl_set_slider_value(GLcp->p_gamma, parms[P_GAMMA]);
  fl_set_slider_value(GLcp->p_sigma, parms[P_SIGMA]);
  fl_set_slider_value(GLcp->p_phi, parms[P_PHI]); 
  fl_set_slider_value(GLcp->p_kappa, parms[P_KAPPA]);
  fl_set_slider_value(GLcp->p_epsilon, parms[P_EPSILON]);
  fl_set_slider_value(GLcp->p_epsilon2, parms[P_EPSILON2]);
  fl_set_slider_value(GLcp->p_epsilon3, parms[P_EPSILON3]);
  fl_set_slider_value(GLcp->p_C, parms[P_C]);
  fl_set_slider_value(GLcp->p_x_1, parms[P_X_1]);
  fl_set_slider_value(GLcp->p_y_1, parms[P_Y_1]);
  fl_set_slider_value(GLcp->p_x_2, parms[P_X_2]);
  fl_set_slider_value(GLcp->p_y_2, parms[P_Y_2]);
  fl_set_slider_value(GLcp->p_m_1, parms[P_M_1]);
  fl_set_slider_value(GLcp->p_m_2, parms[P_M_2]);
  fl_set_slider_value(GLcp->p_beta, parms[P_BETA]);
  fl_set_slider_value(GLcp->p_gamma2, parms[P_GAMMA2]);
  fl_set_slider_value(GLcp->p_sigma2, parms[P_SIGMA2]);
  fl_set_slider_value(GLcp->p_phi2, parms[P_PHI2]);  
  fl_set_slider_value(GLcp->p_sx, parms[P_SX]);
  fl_set_slider_value(GLcp->p_sy, parms[P_SY]);
  fl_set_slider_value(GLcp->p_alpha, parms[P_ALPHA]);
  fl_set_slider_value(GLcp->p_alpha2, parms[P_ALPHA2]);
  fl_set_slider_value(GLcp->p_exp, parms[P_EXP]);  
  fl_set_slider_value(GLcp->p_kappa2, parms[P_KAPPA2]);
  fl_set_slider_value(GLcp->p_rad_i, parms[P_Ri]);
  fl_set_slider_value(GLcp->p_rad_o, parms[P_Ro]);
  fl_set_slider_value(GLcp->p_kappa0, parms[P_KAPPA0]);
  fl_set_slider_value(GLcp->p_dx_qp, parms[P_DX_QP]);
  fl_set_slider_value(GLcp->p_dy_qp, parms[P_DY_QP]);
  fl_set_slider_value(GLcp->p_qxx, parms[P_QXX]);
  fl_set_slider_value(GLcp->p_qxy, parms[P_QXY]);
  fl_set_slider_value(GLcp->p_qyy, parms[P_QYY]);
  fl_set_slider_value(GLcp->p_qyy, parms[P_QYY]);
  fl_set_slider_value(GLcp->p_theta_inc, parms[P_THETA_INC]);
  fl_set_slider_value(GLcp->p_q3, parms[P_Q3]);
  
  /*
    
  printf("X                  = %g \n", Y[0]);
  printf("Y                  = %g \n", Y[1]);  
  printf("parms[P_E]         = %g \n", parms[P_E]);
  printf("parms[P_THETA]     = %g \n", parms[P_THETA]);
  printf("parms[P_GAMMA]     = %g \n", parms[P_GAMMA]);
  printf("parms[P_SIGMA]     = %g \n", parms[P_SIGMA]);
  printf("parms[P_PHI]       = %g \n", parms[P_PHI]);
  printf("parms[P_C]         = %g \n", parms[P_C]);
  printf("parms[P_EPSILON]   = %g \n", parms[P_EPSILON]);
  printf("parms[P_EPSILON2]  = %g \n", parms[P_EPSILON2]);
  printf("parms[P_EPSILON3]  = %g \n", parms[P_EPSILON3]);
  printf("parms[P_ALPHA]     = %g \n", parms[P_ALPHA]);
  printf("parms[P_ALPHA2]    = %g \n", parms[P_ALPHA2]);
  printf("parms[P_KAPPA]     = %g \n", parms[P_KAPPA]);
  printf("parms[P_KAPPA0]    = %g \n", parms[P_KAPPA0]);
  printf("parms[P_KAPPA2]    = %g \n", parms[P_KAPPA2]);
  printf("parms[P_GAMMA2]    = %g \n", parms[P_GAMMA2]);
  printf("parms[P_SIGMA2]    = %g \n", parms[P_SIGMA2]);
  printf("parms[P_PHI2]      = %g \n", parms[P_PHI2]);
  printf("parms[P_Ro]        = %g \n", parms[P_Ro]);
  printf("parms[P_Ri]        = %g \n", parms[P_Ri]);
  printf("parms[P_DX_QP]     = %g \n", parms[P_DX_QP]);
  printf("parms[P_DY_QP]     = %g \n", parms[P_DY_QP]);
  printf("parms[P_QXX]       = %g \n", parms[P_QXX]);
  printf("parms[P_QXY]       = %g \n", parms[P_QXY]);
  printf("parms[P_QYY]       = %g \n", parms[P_QYY]);
  printf("parms[P_SX]        = %g \n", parms[P_SX]);
  printf("parms[P_SY]        = %g \n", parms[P_SY]);
  printf("parms[P_X_1]       = %g \n", parms[P_X_1]);
  printf("parms[P_X_2]       = %g \n", parms[P_X_2]);
  printf("parms[P_Y_1]       = %g \n", parms[P_Y_1]);
  printf("parms[P_Y_2]       = %g \n", parms[P_Y_2]);
  printf("parms[P_M_1]       = %g \n", parms[P_M_1]);
  printf("parms[P_M_2]       = %g \n", parms[P_M_2]);
  printf("parms[P_BETA]      = %g \n", parms[P_BETA]);   
  printf("parms[P_EXP]       = %g \n", parms[P_EXP]);
  printf("parms[P_THETA]     = %g \n", (180.0 * parms[P_THETA] / M_PI));
  printf("parms[P_PHI]       = %g \n", (180.0 * parms[P_PHI] / M_PI));
  printf("parms[P_PHI2]      = %g \n", (180.0 * parms[P_PHI2] / M_PI));
  printf("parms[P_THETA_INC] = %g \n", (180.0 * parms[P_THETA_INC] / M_PI));
  printf("parms[P_Q3]        = %g \n", (180.0 * parms[P_Q3] / M_PI));

  printf("sl_1  = %d \n", sl_1);   
  printf("sl_2  = %d \n", sl_2);   
  printf("sl_3  = %d \n", sl_3);   
  printf("sl_4  = %d \n", sl_4);   
  printf("sl_5  = %d \n", sl_5);   
  printf("sl_6  = %d \n", sl_6);   
  printf("sl_7  = %d \n", sl_7);   
  printf("sl_8  = %d \n", sl_8);   
  printf("sl_9  = %d \n", sl_9);   
  printf("sl_10 = %d \n", sl_10);   
  printf("sl_11 = %d \n", sl_11);   
  printf("sl_12 = %d \n", sl_12);   
  printf("sl_13 = %d \n", sl_13);   
  printf("sl_14 = %d \n", sl_14);   
  printf("sl_15 = %d \n", sl_15);   
  printf("sl_16 = %d \n", sl_16);   
  printf("sl_17 = %d \n", sl_17);   
  printf("sl_18 = %d \n", sl_18);   
  printf("sl_19 = %d \n", sl_19);   
  printf("sl_20 = %d \n", sl_20);   
  printf("sl_21 = %d \n", sl_21);   
  printf("sl_22 = %d \n", sl_22);   
  printf("sl_23 = %d \n", sl_23);   
  printf("sl_24 = %d \n", sl_24);   
  printf("sl_25 = %d \n", sl_25);   
  printf("sl_26 = %d \n", sl_26);   
  printf("sl_27 = %d \n", sl_27);   
  printf("sl_28 = %d \n", sl_28);   
  printf("sl_29 = %d \n", sl_29);   
  printf("sl_30 = %d \n", sl_30);
  printf("sl_31 = %d \n", sl_31);
  printf("sl_32 = %d \n", sl_32);
  printf("sl_33 = %d \n", sl_33);
  printf("sl_34 = %d \n", sl_34);
  
  **/
  
  // SIM_AN = TRUE;
  
  PRAXIS = TRUE;
  
  /* Refresh */     
  
  /* handle_expose(0, 0); */
  
  glXSwapBuffers(fl_display, GLwin);
}

void reset_par(FL_OBJECT *ob, long data)
{
  fl_set_input(Parametres->input_x, "0.0");
  fl_set_input(Parametres->input_y, "0.0");
  fl_set_input(Parametres->input_E, "1.5");
  fl_set_input(Parametres->input_theta, "0.0");
  fl_set_input(Parametres->input_gamma, "0.05");
  fl_set_input(Parametres->input_sigma, "0.05");
  fl_set_input(Parametres->input_phi, "0.0");
  fl_set_input(Parametres->input_gamma2, "0.05");
  fl_set_input(Parametres->input_sigma2, "0.05");
  fl_set_input(Parametres->input_phi2, "0.0");
  fl_set_input(Parametres->input_alpha, "0.2");
  fl_set_input(Parametres->input_alpha2, "1.0");
  fl_set_input(Parametres->input_kappa, "1.0");
  fl_set_input(Parametres->input_kappa0, "1.0");
  fl_set_input(Parametres->input_kappa2, "5.0");
  fl_set_input(Parametres->input_epsilon, "0.4");
  fl_set_input(Parametres->input_epsilon2, "0.4");
  fl_set_input(Parametres->input_epsilon3, "0.4");
  fl_set_input(Parametres->input_beta, "1.0");
  fl_set_input(Parametres->input_C, "1.0");
  fl_set_input(Parametres->input_ri, "1.0");
  fl_set_input(Parametres->input_ro, "2.0");
  fl_set_input(Parametres->input_x1, "0.0");
  fl_set_input(Parametres->input_y1, "0.0");
  fl_set_input(Parametres->input_x2, "0.0");
  fl_set_input(Parametres->input_y2, "0.0");
  fl_set_input(Parametres->input_m1, "0.5");
  fl_set_input(Parametres->input_m2, "0.0");
  fl_set_input(Parametres->input_dx, "1.0");
  fl_set_input(Parametres->input_dy, "1.0");
  fl_set_input(Parametres->input_qxx, "0.1");
  fl_set_input(Parametres->input_qxy, "0.0");
  fl_set_input(Parametres->input_qyy, "-0.1");
  fl_set_input(Parametres->input_sx, "0.5");
  fl_set_input(Parametres->input_sy, "0.5");
  fl_set_input(Parametres->input_exp, "1.0");
  fl_set_input(Parametres->input_thetai, "0.0");
  fl_set_input(Parametres->input_q3, "0.5");
  
  Y[0]               = atof(fl_get_input(Parametres->input_x));  
  Y[1]               = atof(fl_get_input(Parametres->input_y));  
  parms[P_E]         = atof(fl_get_input(Parametres->input_E));
  parms[P_THETA]     = atof(fl_get_input(Parametres->input_theta));
  parms[P_GAMMA]     = atof(fl_get_input(Parametres->input_gamma));
  parms[P_SIGMA]     = atof(fl_get_input(Parametres->input_sigma));
  parms[P_PHI]       = atof(fl_get_input(Parametres->input_phi));
  parms[P_GAMMA2]    = atof(fl_get_input(Parametres->input_gamma2));
  parms[P_SIGMA2]    = atof(fl_get_input(Parametres->input_sigma2));
  parms[P_PHI2]      = atof(fl_get_input(Parametres->input_phi2));
  parms[P_ALPHA]     = atof(fl_get_input(Parametres->input_alpha));
  parms[P_ALPHA2]    = atof(fl_get_input(Parametres->input_alpha2));  
  parms[P_KAPPA]     = atof(fl_get_input(Parametres->input_kappa));
  parms[P_KAPPA0]    = atof(fl_get_input(Parametres->input_kappa0));
  parms[P_KAPPA2]    = atof(fl_get_input(Parametres->input_kappa2));
  parms[P_EPSILON]   = atof(fl_get_input(Parametres->input_epsilon));
  parms[P_EPSILON2]  = atof(fl_get_input(Parametres->input_epsilon2));
  parms[P_EPSILON3]  = atof(fl_get_input(Parametres->input_epsilon3));
  parms[P_BETA]      = atof(fl_get_input(Parametres->input_beta));
  parms[P_C]         = atof(fl_get_input(Parametres->input_C));
  parms[P_Ri]        = atof(fl_get_input(Parametres->input_ri));
  parms[P_Ro]        = atof(fl_get_input(Parametres->input_ro));
  parms[P_X_1]       = atof(fl_get_input(Parametres->input_x1));
  parms[P_Y_1]       = atof(fl_get_input(Parametres->input_y1));
  parms[P_M_1]       = atof(fl_get_input(Parametres->input_m1));
  parms[P_X_2]       = atof(fl_get_input(Parametres->input_x2));
  parms[P_Y_2]       = atof(fl_get_input(Parametres->input_y2));
  parms[P_M_2]       = atof(fl_get_input(Parametres->input_m2));
  parms[P_DX_QP]     = atof(fl_get_input(Parametres->input_dx));
  parms[P_DY_QP]     = atof(fl_get_input(Parametres->input_dy));
  parms[P_QXX]       = atof(fl_get_input(Parametres->input_qxx));
  parms[P_QXY]       = atof(fl_get_input(Parametres->input_qxy));
  parms[P_QYY]       = atof(fl_get_input(Parametres->input_qyy));
  parms[P_SX]        = atof(fl_get_input(Parametres->input_sx));
  parms[P_SY]        = atof(fl_get_input(Parametres->input_sy));
  parms[P_EXP]       = atof(fl_get_input(Parametres->input_exp));
  parms[P_THETA_INC] = atof(fl_get_input(Parametres->input_thetai));
  parms[P_Q3]        = atof(fl_get_input(Parametres->input_q3));
  
  fl_set_positioner_xvalue(GLcp->source_pos, Y[0]);
  fl_set_positioner_yvalue(GLcp->source_pos, Y[1]);
  
  fl_set_counter_value(GLcp->x_pos, Y[0]);
  fl_set_counter_value(GLcp->y_pos, Y[1]);
  
  fl_set_slider_value(GLcp->p_E, parms[P_E]);
  fl_set_slider_value(GLcp->p_theta, parms[P_THETA]);
  fl_set_slider_value(GLcp->p_gamma, parms[P_GAMMA]);
  fl_set_slider_value(GLcp->p_sigma, parms[P_SIGMA]);
  fl_set_slider_value(GLcp->p_phi, parms[P_PHI]);
  fl_set_slider_value(GLcp->p_kappa, parms[P_KAPPA]);
  fl_set_slider_value(GLcp->p_epsilon, parms[P_EPSILON]);
  fl_set_slider_value(GLcp->p_epsilon, parms[P_EPSILON2]);
  fl_set_slider_value(GLcp->p_epsilon, parms[P_EPSILON3]);
  fl_set_slider_value(GLcp->p_C, parms[P_C]);
  fl_set_slider_value(GLcp->p_x_1, parms[P_X_1]);
  fl_set_slider_value(GLcp->p_y_1, parms[P_Y_1]);
  fl_set_slider_value(GLcp->p_x_2, parms[P_X_2]);
  fl_set_slider_value(GLcp->p_y_2, parms[P_Y_2]);
  fl_set_slider_value(GLcp->p_m_1, parms[P_M_1]);
  fl_set_slider_value(GLcp->p_m_2, parms[P_M_2]);
  fl_set_slider_value(GLcp->p_beta, parms[P_BETA]);
  fl_set_slider_value(GLcp->p_gamma2, parms[P_GAMMA2]);
  fl_set_slider_value(GLcp->p_sigma2, parms[P_SIGMA2]);
  fl_set_slider_value(GLcp->p_phi2, parms[P_PHI2]);
  fl_set_slider_value(GLcp->p_sx, parms[P_SX]);
  fl_set_slider_value(GLcp->p_sy, parms[P_SY]);
  fl_set_slider_value(GLcp->p_alpha, parms[P_ALPHA]);
  fl_set_slider_value(GLcp->p_alpha2, parms[P_ALPHA2]);
  fl_set_slider_value(GLcp->p_exp, parms[P_EXP]);  
  fl_set_slider_value(GLcp->p_kappa2, parms[P_KAPPA2]);
  fl_set_slider_value(GLcp->p_rad_i, parms[P_Ri]);
  fl_set_slider_value(GLcp->p_rad_o, parms[P_Ro]);
  fl_set_slider_value(GLcp->p_kappa0, parms[P_KAPPA0]);
  fl_set_slider_value(GLcp->p_dx_qp, parms[P_DX_QP]);
  fl_set_slider_value(GLcp->p_dy_qp, parms[P_DY_QP]);
  fl_set_slider_value(GLcp->p_qxx, parms[P_QXX]);
  fl_set_slider_value(GLcp->p_qxy, parms[P_QXY]);
  fl_set_slider_value(GLcp->p_qyy, parms[P_QYY]);
  fl_set_slider_value(GLcp->p_theta_inc, parms[P_THETA_INC]);
  fl_set_slider_value(GLcp->p_q3, parms[P_Q3]);
  
  // SIM_AN = FALSE;
  
  PRAXIS = FALSE;
  
  sl_model    = FALSE;        
  sl_macro    = FALSE;        
  sl_re       = FALSE;
  sl_position = FALSE;
  
  sl_1  = FALSE;      
  sl_2  = FALSE;      
  sl_3  = FALSE;
  sl_4  = FALSE;
  sl_5  = FALSE;
  sl_6  = FALSE;
  sl_7  = FALSE;
  sl_8  = FALSE;
  sl_9  = FALSE;
  sl_10 = FALSE;
  sl_11 = FALSE;
  sl_12 = FALSE;
  sl_13 = FALSE;
  sl_14 = FALSE;
  sl_15 = FALSE;
  sl_16 = FALSE;
  sl_17 = FALSE;
  sl_18 = FALSE;
  sl_19 = FALSE;
  sl_20 = FALSE;
  sl_21 = FALSE;
  sl_22 = FALSE;
  sl_23 = FALSE;
  sl_24 = FALSE;
  sl_25 = FALSE;
  sl_26 = FALSE;
  sl_27 = FALSE;
  sl_28 = FALSE;
  sl_29 = FALSE;
  sl_30 = FALSE;
  sl_31 = FALSE;
  sl_32 = FALSE;
  sl_33 = FALSE;
  sl_34 = FALSE;
  sl_35 = FALSE;
  sl_36 = FALSE;
  sl_37 = FALSE;
  sl_38 = FALSE;
  sl_39 = FALSE;
  sl_40 = FALSE;
  
  /* Refresh */     

  /* handle_expose(0, 0); */

  glXSwapBuffers(fl_display, GLwin);
}

void ex_par(FL_OBJECT *ob, long data)
{
  fl_hide_form(Parametres->Parameters);
  fl_activate_object(GLcp->model_ps);
}

void fit_par(FL_OBJECT *ob, long data)
{
  printf("Optimizing switch \n");
  printf("In this window choose the parameters to be optimized, \n");
  printf("but first of all you have to set the number of parameter on the"
	 " main window. \n");

  sl_opt = TRUE;
}

/* callbacks and freeobj handles for form Help */

void cb_help(FL_OBJECT *ob, long data)
{
  Help = create_form_Help();
  
  if(fl_mouse_button())
    fl_show_form(Help->Help_me, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Help Window");

  fl_deactivate_object(GLcp->help_win);
}

void exit_help(FL_OBJECT *ob, long data)
{
  fl_hide_form(Help->Help_me);
  fl_activate_object(GLcp->help_win);
}

/* callbacks and freeobj handles for form Oposition */

void cb_oposition(FL_OBJECT *ob, long data)
{
  Oposition = create_form_Oposition();
  
  if(fl_mouse_button())
    fl_show_form(Oposition->O_position, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Input Window for Observed Image Positions");

  fl_deactivate_object(GLcp->obip);
}

void cb_image_coordinates_add(FL_OBJECT *ob, long data)
{
  FD_Oposition *main_form = (FD_Oposition *) data; 

  char s[1024];

  sprintf(s, "%s; %s",
          fl_get_input(main_form->imp_x), fl_get_input(main_form->imp_y));
  fl_add_browser_line(main_form->image_locations, s);

  x_obs[Index2] = atof(fl_get_input(main_form->imp_x));
  y_obs[Index2] = atof(fl_get_input(main_form->imp_y));

  Index2 +=1;
}

void cb_image_coordinates_replace(FL_OBJECT *ob, long data)
{
  FD_Oposition *main_form = (FD_Oposition *)data; 

  char s[1024];
  int n;

  if((n=fl_get_browser(main_form->image_locations))) {
    sprintf(s, "%s; %s",
	    fl_get_input(main_form->imp_x),
	    fl_get_input(main_form->imp_y));
    fl_replace_browser_line(main_form->image_locations, n, s);
  }

  x_obs[Index2] = atof(fl_get_input(main_form->imp_x));
  y_obs[Index2] = atof(fl_get_input(main_form->imp_y));

  Index2 +=1;
}

void cb_image_coordinates_remove(FL_OBJECT *ob, long data)
{
  FD_Oposition *main_form = (FD_Oposition *)data; 

  int n;
  
  if((n=fl_get_browser(main_form->image_locations)))
    fl_delete_browser_line(main_form->image_locations,n);

  x_obs[Index2] = 0.0;
  y_obs[Index2] = 0.0;

  Index2 -= 1;
}

void cb_image_coordinates_clear(FL_OBJECT *ob, long data)
{
  int i;
  
  FD_Oposition *main_form = (FD_Oposition *) data; 

  fl_clear_browser(main_form->image_locations);

  Index2 = 0;

  for(i = 0; i < Number_of_images; i++) {
    x_obs[i] = 0.0;
    y_obs[i] = 0.0;
  }
}

void cb_imp(FL_OBJECT *ob, long data)
{
  char s1[9], s2[9];

  FD_Oposition *main_form = (FD_Oposition *)data; 

  int n;

  if(ob != (main_form->image_locations))
    return;

  if((n=fl_get_browser(main_form->image_locations))) {
    sscanf(fl_get_browser_line(ob, n),
	   "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);
    fl_set_input(main_form->imp_x, s1);
    fl_set_input(main_form->imp_y, s2);
  }
}

void cb_obimpos(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  GLUquadricObj *qobj = gluNewQuadric();

  int n, i;
  char s1[9], s2[9];
  double x, y;

  glColor3f(0.0, 1.0, 0.0);

  /* gluQuadricDrawStyle(qobj, GLU_SILHOUETTE); */

  /* glPushMatrix();  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();  */

  if(fl_get_button(ob)) {
    n = fl_get_browser_maxline(Oposition->image_locations);
      
    for(i = 1; i <= n; ++i) {
      sscanf(fl_get_browser_line(Oposition->image_locations, i),
             "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);

      x = strtod(s1, NULL);
      y = strtod(s2, NULL);

      gluQuadricDrawStyle(qobj, GLU_SILHOUETTE);
      glTranslated(x, y, 0.0); 	
      gluDisk(qobj, 0.10, 0.75, 32, 1);
    }
  }

  /* glTranslated(1.0, 1.0, 0.0); */
  /* gluDisk(qobj, 0.20, 0.40, 32, 3); */

  glPopMatrix();     
  gluDeleteQuadric(qobj); 

  /* Refresh */
 
  handle_expose(0, 0);
}

void cb_impset(FL_OBJECT *ob, long data)
{
  int i; 

  Number_of_images = atoi(fl_get_input(Oposition->inp_noim));
  
  printf("Number_of_images = %d \n", Number_of_images); 

  for(i = 0; i < Number_of_images; i++) {
    printf("x_obs[%d] = %g, y_obs[%d] = %g \n", i, x_obs[i], i, y_obs[i]);
  }
}

void cb_impreset(FL_OBJECT *ob, long data)
{
  int i;

  Number_of_images = atoi(fl_get_input(Oposition->inp_noim));
  
  /* printf("Number_of_images = %d\n", Number_of_images); */

  Index2 = 0;
  
  for(i = 0; i < Number_of_images; i++) {
    x_obs[i] = 0.0;
    y_obs[i] = 0.0;
  }
}

void exit_op(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_hide_form(Oposition->O_position);
  fl_activate_object(GLcp->obip);
}

void cb_root_positions(FL_OBJECT *ob, long data)
{
  int ir = 0, color = 4;
  double dxi = 1.0;
  double dxf, dyf;
  double xf  = 4.0;  

  VEC x_init;

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
  case M_SING_ISOT_SPHERE:
  case M_DE_VAUCOULEUR:
  case M_KING:
  case M_HUBBLE:
  case M_SPIRAL:
  case M_TRUNC_KING:
  case M_NSING_ISOT_SPHERE:
  case M_TRANSP_SPHERE:
  case M_ELLIPTICAL:
  case M_MULTIPOLE:
  case M_ROTATION_LENS:
  case M_DOUBLE_LENS:
  case M_UNIFORM_RING:
    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      for(dyf = - xf; dyf <= xf; dyf += dxi) {    
	x_init[0] = dxf; 
	x_init[1] = dyf;
	
	roots(x_init, ir, color);       

	ir += 1;
      }
    }
    
    break;
  default:
    break;
  }
  
  glXSwapBuffers(fl_display, GLwin);
}

void cb_drawroots(FL_OBJECT *ob, long data)
{
  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
  case M_SING_ISOT_SPHERE:
  case M_DE_VAUCOULEUR:
  case M_KING:
  case M_HUBBLE:
  case M_SPIRAL:
  case M_TRUNC_KING:
  case M_NSING_ISOT_SPHERE:
  case M_TRANSP_SPHERE:
  case M_ELLIPTICAL:
  case M_MULTIPOLE:
  case M_ROTATION_LENS:
  case M_DOUBLE_LENS:
  case M_UNIFORM_RING:
    root_finder(Swept, Zero, 4);      
    break;
  default:
    break;
  }

  // draw_niveau();

  glXSwapBuffers(fl_display, GLwin);
}

void cb_min_td(FL_OBJECT *ob, long data)
{  
  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
  case M_SING_ISOT_SPHERE:
  case M_DE_VAUCOULEUR:
  case M_KING:
  case M_HUBBLE:
  case M_SPIRAL:
  case M_TRUNC_KING:
  case M_NSING_ISOT_SPHERE:
  case M_TRANSP_SPHERE:
  case M_ELLIPTICAL:
  case M_MULTIPOLE:
  case M_ROTATION_LENS:
  case M_DOUBLE_LENS:
  case M_UNIFORM_RING:
    // minimum_time_delay(); 

    break;
  default:
    break;
  }     

  glXSwapBuffers(fl_display, GLwin);      
} 

void cb_opt_siman(FL_OBJECT *ob, long data)
{
  char s[10], s2[10];

  Optimum = create_form_Optimum();
  
  if(fl_mouse_button())
    fl_show_form(Optimum->Optimum, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Optimization Window");

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_params = 7;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_params = 8;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_params = 8;
    break;       
  case M_KING:
    Number_of_params = 8;   
    break;
  case M_HUBBLE:
    Number_of_params = 8;   
    break;
  case M_SPIRAL:
    Number_of_params = 9;   
    break;    
  case M_TRUNC_KING:
    Number_of_params = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_params = 9;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_params = 8;   
    break;
  case M_ELLIPTICAL:
    Number_of_params = 11;   
    break;
  case M_MULTIPOLE:
    Number_of_params = 13;   
    break;
  case M_ROTATION_LENS:
    Number_of_params = 9;   
    break;
  case M_DOUBLE_LENS:
    Number_of_params = 17;   
    break;
  case M_UNIFORM_RING:
    Number_of_params = 10;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_params);
  sprintf(s2, "%d", N_constraints);

  fl_set_input(Optimum->inp_nop, s);
  fl_set_input(Optimum->n_consts, s2);

  fl_deactivate_object(GLcp->optimum);
}

void cb_optimum(FL_OBJECT *ob, long data)
{
  char s[10], s2[10];

  Optimum = create_form_Optimum();
  
  if(fl_mouse_button())
    fl_show_form(Optimum->Optimum, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Optimization Window");

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_params = 7;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_params = 8;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_params = 8;
    break;       
  case M_KING:
    Number_of_params = 8;   
    break;
  case M_HUBBLE:
    Number_of_params = 8;   
    break;
  case M_SPIRAL:
    Number_of_params = 9;   
    break;    
  case M_TRUNC_KING:
    Number_of_params = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_params = 9;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_params = 8;   
    break;
  case M_ELLIPTICAL:
    Number_of_params = 11;   
    break;
  case M_MULTIPOLE:
    Number_of_params = 13;   
    break;
  case M_ROTATION_LENS:
    Number_of_params = 9;   
    break;
  case M_DOUBLE_LENS:
    Number_of_params = 17;   
    break;
  case M_UNIFORM_RING:
    Number_of_params = 10;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_params);
  sprintf(s2, "%d", N_constraints);

  fl_set_input(Optimum->inp_nop, s);
  fl_set_input(Optimum->n_consts, s2);

  fl_deactivate_object(GLcp->optimum);
}

void ex_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_hide_form(Optimum->Optimum);
  fl_activate_object(GLcp->optimum);
}

void number_var_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  Number_of_params = atoi(fl_get_input(ob));

  printf("Number of parameters to optimize = %d \n", Number_of_params);

  if(sl_opt == FALSE ) {
    printf("If you want to optimize a model, first of all choose the model,"
	   " then the parameters to be optimized");
  } else {
    X_opt = (double *) malloc(Number_of_params * sizeof(double));
  }
}

void optim_of_models(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s1[10],  s2[10],  s3[10],  s4[10],  s5[10],  s6[10],  s7[10],  s8[10];
  char s9[10],  s10[10], s11[10], s12[10], s13[10], s14[10], s15[10], s16[10];
  char s17[10], s18[10], s19[10], s20[10], s21[10], s22[10], s23[10], s24[10];
  char s25[10], s26[10], s27[10], s28[10], s29[10], s30[10], s31[10], s32[10];
  char s33[10], s34[10], s35[10], s36[10], s37[10], s38[10], s39[10], s40[10];

  // optimization(); 

  // main_praxis();
  
  if(sl_1 == FALSE || sl_2 == FALSE) {
    printf("Choose the parameters that have to be optimized"
	   " in the model parameter window. \n");
  } else {
    
    

    sprintf(s1, "%g", Y[0]);
    fl_set_input(Parametres->input_x, s1);  
    
    sprintf(s2, "%g", Y[1]);
    fl_set_input(Parametres->input_y, s2);  
    
    sprintf(s3, "%g", parms[P_E]);
    fl_set_input(Parametres->input_E, s3);  
    
    sprintf(s4, "%g", parms[P_THETA]);
    fl_set_input(Parametres->input_theta, s4);  
    
    sprintf(s5, "%g", parms[P_GAMMA]);
    fl_set_input(Parametres->input_gamma, s5);  
    
    sprintf(s6, "%g", parms[P_SIGMA]);
    fl_set_input(Parametres->input_sigma, s6);  
    
    sprintf(s7, "%g", parms[P_PHI]);
    fl_set_input(Parametres->input_phi, s7);  
    
    sprintf(s8, "%g", parms[P_KAPPA]);
    fl_set_input(Parametres->input_kappa, s8);  
    
    sprintf(s9, "%g", parms[P_EPSILON]);
    fl_set_input(Parametres->input_epsilon, s9);
    
    sprintf(s10, "%g", parms[P_C]);
    fl_set_input(Parametres->input_C, s10);  
    
    sprintf(s11, "%g", parms[P_X_1]);
    fl_set_input(Parametres->input_x1, s11);  
    
    sprintf(s12, "%g", parms[P_Y_1]);
    fl_set_input(Parametres->input_y1, s12);  
    
    sprintf(s13, "%g", parms[P_X_1]);
    fl_set_input(Parametres->input_x2, s13);  
    
    sprintf(s14, "%g", parms[P_Y_2]);
    fl_set_input(Parametres->input_y2, s14);  
    
    sprintf(s15, "%g", parms[P_M_1]);
    fl_set_input(Parametres->input_m1, s15);  
    
    sprintf(s16, "%g", parms[P_M_2]);
    fl_set_input(Parametres->input_m2, s16);  
    
    sprintf(s17, "%g", parms[P_BETA]);
    fl_set_input(Parametres->input_beta, s17);  
    
    sprintf(s18, "%g", parms[P_GAMMA2]);
    fl_set_input(Parametres->input_gamma2, s18);  
    
    sprintf(s19, "%g", parms[P_SIGMA2]);
    fl_set_input(Parametres->input_sigma2, s19);  
    
    sprintf(s20, "%g", parms[P_PHI2]);
    fl_set_input(Parametres->input_phi2, s20);
    
    sprintf(s21, "%g", parms[P_SX]);
    fl_set_input(Parametres->input_sx, s21);  
    
    sprintf(s22, "%g", parms[P_SY]);
    fl_set_input(Parametres->input_sy, s22);  
    
    sprintf(s23, "%g", parms[P_ALPHA]);
    fl_set_input(Parametres->input_alpha, s23);  
    
    sprintf(s24, "%g", parms[P_ALPHA2]);
    fl_set_input(Parametres->input_alpha2, s24);  
    
    sprintf(s25, "%g", parms[P_ALPHA3]);  
    fl_set_input(Parametres->input_alpha3, s25);
    
    sprintf(s26, "%g", parms[P_EXP]);
    fl_set_input(Parametres->input_exp, s26);  
    
    sprintf(s27, "%g", parms[P_KAPPA2]);
    fl_set_input(Parametres->input_kappa2, s27);  
    
    sprintf(s28, "%g", parms[P_Ri]);
    fl_set_input(Parametres->input_ri, s28);  
    
    sprintf(s29, "%g", parms[P_Ro]);
    fl_set_input(Parametres->input_ro, s29);  
    
    sprintf(s30, "%g", parms[P_Ko]);
    fl_set_input(Parametres->input_ko, s30);    
    
    sprintf(s31, "%g", parms[P_KAPPA0]);
    fl_set_input(Parametres->input_kappa0, s31);  
    
    sprintf(s32, "%g", parms[P_DX_QP]);
    fl_set_input(Parametres->input_dx, s32);  
    
    sprintf(s33, "%g", parms[P_DY_QP]);
    fl_set_input(Parametres->input_dy, s33);  
    
    sprintf(s34, "%g", parms[P_QXX]);
    fl_set_input(Parametres->input_qxx, s34);  
    
    sprintf(s35, "%g", parms[P_QXY]);
    fl_set_input(Parametres->input_qxy, s35);  
    
    sprintf(s36, "%g", parms[P_QYY]);
    fl_set_input(Parametres->input_qyy, s36);  
    
    sprintf(s37, "%g", parms[P_THETA_INC]);
    fl_set_input(Parametres->input_thetai, s37);  
    
    sprintf(s38, "%g", parms[P_Q3]);
    fl_set_input(Parametres->input_q3, s38);  
    
    sprintf(s39, "%g", parms[P_EPSILON2]);
    fl_set_input(Parametres->input_epsilon2, s39);  
    
    sprintf(s40, "%g", parms[P_EPSILON3]);
    fl_set_input(Parametres->input_epsilon3, s40);  
    
    fl_set_positioner_xvalue(GLcp->source_pos, xl);
    fl_set_positioner_yvalue(GLcp->source_pos, yl);
    fl_set_counter_value(GLcp->x_pos, xl);
    fl_set_counter_value(GLcp->y_pos, yl);
    
    fl_set_slider_value(GLcp->p_E, Prmt[3]);
    fl_set_slider_value(GLcp->p_theta, Prmt[4]);
    fl_set_slider_value(GLcp->p_gamma, Prmt[5]);
    fl_set_slider_value(GLcp->p_sigma, Prmt[6]);
    fl_set_slider_value(GLcp->p_phi, Prmt[7]);
    fl_set_slider_value(GLcp->p_kappa, Prmt[8]);
    fl_set_slider_value(GLcp->p_epsilon, Prmt[9]);
    fl_set_slider_value(GLcp->p_C, Prmt[10]);
    fl_set_slider_value(GLcp->p_x_1, Prmt[11]);
    fl_set_slider_value(GLcp->p_y_1, Prmt[12]);
    fl_set_slider_value(GLcp->p_x_2, Prmt[13]);
    fl_set_slider_value(GLcp->p_y_2, Prmt[14]);
    fl_set_slider_value(GLcp->p_m_1, Prmt[15]);
    fl_set_slider_value(GLcp->p_m_2, Prmt[16]);
    fl_set_slider_value(GLcp->p_beta, Prmt[17]);
    fl_set_slider_value(GLcp->p_gamma2, Prmt[18]);
    fl_set_slider_value(GLcp->p_sigma2, Prmt[19]);
    fl_set_slider_value(GLcp->p_phi2, Prmt[20]);
    fl_set_slider_value(GLcp->p_sx, Prmt[21]);
    fl_set_slider_value(GLcp->p_sy, Prmt[22]);
    fl_set_slider_value(GLcp->p_alpha, Prmt[23]);
    fl_set_slider_value(GLcp->p_alpha2, Prmt[24]);
    fl_set_slider_value(GLcp->p_alpha3, Prmt[25]);
    fl_set_slider_value(GLcp->p_exp, Prmt[26]);  
    fl_set_slider_value(GLcp->p_kappa2, Prmt[27]);
    fl_set_slider_value(GLcp->p_rad_i, Prmt[28]);
    fl_set_slider_value(GLcp->p_rad_o, Prmt[29]);
    fl_set_slider_value(GLcp->p_ko, Prmt[30]);
    fl_set_slider_value(GLcp->p_kappa0, Prmt[31]);
    fl_set_slider_value(GLcp->p_dx_qp, Prmt[32]);
    fl_set_slider_value(GLcp->p_dy_qp, Prmt[33]);
    fl_set_slider_value(GLcp->p_qxx, Prmt[34]);
    fl_set_slider_value(GLcp->p_qxy, Prmt[35]);
    fl_set_slider_value(GLcp->p_qyy, Prmt[36]);
    fl_set_slider_value(GLcp->p_theta_inc, Prmt[37]);
    fl_set_slider_value(GLcp->p_q3, Prmt[38]);    
    fl_set_slider_value(GLcp->p_epsilon2, Prmt[39]);
    fl_set_slider_value(GLcp->p_epsilon3, Prmt[40]);    
  }
  
  /* Refresh */     
  
  /* handle_expose(0, 0); */
  
  glXSwapBuffers(fl_display, GLwin);
}

void set_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  // char s[10];

  /* If w_p = 1 then w_a = 0 and vice versa */
  
  w_p = fl_get_slider_value(Optimum->wg_p);
  w_a = fl_get_slider_value(Optimum->wg_a);
  
  if(w_p == 1.0) {
    fl_set_slider_value(Optimum->wg_a, 0.0);
  }     

  if(w_a == 1.0 && w_p == 0.0) {
    fl_set_slider_value(Optimum->wg_p, 0.0);
  } else {
    fl_set_slider_value(Optimum->wg_a, 0.0);    
  }

  /*

  sprintf(s, "%d", Number_of_params);
  
  fl_set_input(Optimum->inp_nop, s);

  **/

  /* printf("Number_of_params = %d \n", Number_of_params); */

  N_constraints = atoi(fl_get_input(Optimum->n_consts));

  /* printf("N_constraints = %d \n", N_constraints); */

  // SIM_AN = TRUE;

  PRAXIS = TRUE;

  printf("PRAXIS = %d \n", PRAXIS); 
}

void reset_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  char s[10];

  switch(current_model) {
  case M_MODEL_MENU:
    break;
  case M_CHANG_REFSDAL:    
    Number_of_params = 7;   
    break;
  case M_SING_ISOT_SPHERE:
    Number_of_params = 8;   
    break;
  case M_DE_VAUCOULEUR:
    Number_of_params = 8;   
    break;       
  case M_KING:
    Number_of_params = 8;   
    break;
  case M_HUBBLE:
    Number_of_params = 8;   
    break;
  case M_SPIRAL:
    Number_of_params = 9;           
    break;    
  case M_TRUNC_KING:
    Number_of_params = 9;   
    break;
  case M_NSING_ISOT_SPHERE:
    Number_of_params = 9;   
    break;
  case M_TRANSP_SPHERE:
    Number_of_params = 8;   
    break;
  case M_ELLIPTICAL:
    Number_of_params = 11;   
    break;
  case M_MULTIPOLE:
    Number_of_params = 13;
    break;
  case M_ROTATION_LENS:
    Number_of_params = 9;   
    break;
  case M_DOUBLE_LENS:
    Number_of_params = 17;   
    break;
  case M_UNIFORM_RING:
    Number_of_params = 10;   
    break;
  default:
    break;
  }

  sprintf(s, "%d", Number_of_params);

  fl_set_input(Optimum->inp_nop, s);

  // SIM_AN = FALSE;

  PRAXIS = FALSE;

  sl_model    = FALSE;
  sl_macro    = FALSE;
  sl_re       = FALSE;
  sl_position = FALSE;
  
  sl_1  = FALSE;
  sl_2  = FALSE;
  sl_3  = FALSE;
  sl_4  = FALSE;
  sl_5  = FALSE;
  sl_6  = FALSE;
  sl_7  = FALSE;
  sl_8  = FALSE;
  sl_9  = FALSE;
  sl_10 = FALSE;
  sl_11 = FALSE;
  sl_12 = FALSE;
  sl_13 = FALSE;
  sl_14 = FALSE;
  sl_15 = FALSE;
  sl_16 = FALSE;
  sl_17 = FALSE;
  sl_18 = FALSE;
  sl_19 = FALSE;
  sl_20 = FALSE;
  sl_21 = FALSE;
  sl_22 = FALSE;
  sl_23 = FALSE;
  sl_24 = FALSE;
  sl_25 = FALSE;
  sl_26 = FALSE;
  sl_27 = FALSE;
  sl_28 = FALSE;
  sl_29 = FALSE;
  sl_30 = FALSE;
  sl_31 = FALSE;
  sl_32 = FALSE;
  sl_33 = FALSE;
  sl_34 = FALSE;
  sl_35 = FALSE;
  sl_36 = FALSE;
  sl_37 = FALSE;
  sl_38 = FALSE;
  sl_39 = FALSE;
  sl_40 = FALSE;
}

void done_opt(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_activate_object(GLcp->model_ps);  
}

void model_opt(FL_OBJECT *ob, long data)
{
  sl_model = TRUE;

  printf("Model Parameters --> True \n");
}

void macro_opt(FL_OBJECT *ob, long data)
{
  sl_macro = TRUE;

  printf("Macro Parameters --> True \n");
}

void cb_scale(FL_OBJECT *ob, long data)
{
  sl_re = TRUE;
}

void cb_position(FL_OBJECT *ob, long data)
{
  sl_position = TRUE;
}

void cb_sl1(FL_OBJECT *ob, long data)
{
  printf("The lens position (x_lens, y_lens) will be optimized \n");
}

void cb_sl2(FL_OBJECT *ob, long data)
{
  printf("The lens position (x_lens, y_lens) will be optimized \n");
}

void cb_sl3(FL_OBJECT *ob, long data)
{
  printf("The scale parameter E will be optimized \n");
}

void cb_sl4(FL_OBJECT *ob, long data)
{

}

void cb_sl5(FL_OBJECT *ob, long data)
{

}

void cb_sl6(FL_OBJECT *ob, long data)
{

}

void cb_sl7(FL_OBJECT *ob, long data)
{

}

void cb_sl8(FL_OBJECT *ob, long data)
{

}

void cb_sl9(FL_OBJECT *ob, long data)
{
}

void cb_sl10(FL_OBJECT *ob, long data)
{

}

void cb_sl11(FL_OBJECT *ob, long data)
{

}

void cb_sl12(FL_OBJECT *ob, long data)
{

}

void cb_sl13(FL_OBJECT *ob, long data)
{

}

void cb_sl14(FL_OBJECT *ob, long data)
{

}

void cb_sl15(FL_OBJECT *ob, long data)
{

}

void cb_sl16(FL_OBJECT *ob, long data)
{

}

void cb_sl17(FL_OBJECT *ob, long data)
{

}

void cb_sl18(FL_OBJECT *ob, long data)
{

}

void cb_sl19(FL_OBJECT *ob, long data)
{

}

void cb_sl20(FL_OBJECT *ob, long data)
{

}

void cb_sl21(FL_OBJECT *ob, long data)
{

}

void cb_sl522(FL_OBJECT *ob, long data)
{

}

void cb_sl23(FL_OBJECT *ob, long data)
{

}

void cb_sl24(FL_OBJECT *ob, long data)
{

}

void cb_sl25(FL_OBJECT *ob, long data)
{

}

void cb_sl26(FL_OBJECT *ob, long data)
{
}

void cb_sl27(FL_OBJECT *ob, long data)
{

}

void cb_sl28(FL_OBJECT *ob, long data)
{

}

void cb_sl29(FL_OBJECT *ob, long data)
{

}

void cb_sl30(FL_OBJECT *ob, long data)
{

}

void cb_sl31(FL_OBJECT *ob, long data)
{

}

void cb_sl32(FL_OBJECT *ob, long data)
{

}

void cb_sl33(FL_OBJECT *ob, long data)
{

}

void cb_sl34(FL_OBJECT *ob, long data)
{

}

void cb_sl35(FL_OBJECT *ob, long data)
{

}

void cb_sl36(FL_OBJECT *ob, long data)
{

}

void cb_sl37(FL_OBJECT *ob, long data)
{

}

void cb_sl38(FL_OBJECT *ob, long data)
{

}

void cb_sl39(FL_OBJECT *ob, long data)
{

}

void cb_sl40(FL_OBJECT *ob, long data)
{

}

void cb_sa(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    Number_of_params -= 1;
  }
}

void cb_sa1(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_1        = TRUE;
    sl_position = TRUE;
  } else {
    sl_1        = FALSE;
    sl_position = FALSE;
  }

  printf("In any case, the lens position (x_lens, y_lens) will be optimized!");
  printf("\n");
  printf("Index = %d \n", Index);
}

void cb_sa2(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob)) {
    sl_2        = TRUE;
    sl_position = TRUE;
  } else {
    sl_2        = FALSE;
    sl_position = FALSE;
  }

  printf("In any case, the lens position (x_lens, y_lens) will be optimized!");
  printf("\n");
  printf("Index = %d \n", Index);
}

void cb_sa3(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_3 = TRUE;
    Index++;

    printf("Optimizing --> E \n");
    printf("Index = %d \n", Index);

    Xprmt[P_E]       = parms[P_E];
    X_opt[Index - 1] = Xprmt[P_E];
  } else {
    sl_3 = FALSE;
  }
}

void cb_sa4(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_4 = TRUE;
    Index++;

    printf("Optimizing --> theta \n");
    printf("Index = %d \n", Index);

    Xprmt[P_THETA]   = parms[P_THETA];
    X_opt[Index - 1] = Xprmt[P_THETA];
  } else {
    sl_4 = FALSE;
  }
}

void cb_sa5(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_5 = TRUE;
    Index++;

    printf("Optimizing --> gamma \n");
    printf("Index = %d \n", Index);

    Xprmt[P_GAMMA]   = parms[P_GAMMA];
    X_opt[Index - 1] = Xprmt[P_GAMMA];
  } else {
    sl_5 = FALSE;
  }
}

void cb_sa6(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_6 = TRUE;
    Index++;

    printf("Optimizing --> sigma \n");
    printf("Index = %d \n", Index);

      Xprmt[P_SIGMA]   = parms[P_SIGMA];
      X_opt[Index - 1] = Xprmt[P_SIGMA];
  } else {
    sl_6 = FALSE;
  }
}

void cb_sa7(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_7 = TRUE;
    Index++;

    printf("Optimizing --> phi \n");
    printf("Index = %d \n", Index);

    Xprmt[P_PHI]     = parms[P_PHI];
    X_opt[Index - 1] = Xprmt[P_PHI];    
  } else {
    sl_7 = FALSE;
  }
}

void cb_sa8(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_8 = TRUE;
    Index++;

    printf("Optimizing --> kappa \n");
    printf("Index = %d \n", Index);

    Xprmt[P_KAPPA]   = parms[P_KAPPA];
    X_opt[Index - 1] = Xprmt[P_KAPPA];
  } else {
    sl_8 = FALSE;
  }
}

void cb_sa9(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_9 = TRUE;
    Index++;

    printf("Optimizing --> epsilon \n");
    printf("Index = %d \n", Index);

    Xprmt[P_EPSILON] = parms[P_EPSILON];
    X_opt[Index - 1] = Xprmt[P_EPSILON];
  } else {
    sl_9 = FALSE;
  }
}

void cb_sa10(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_10 = TRUE;
    Index++;

    printf("Optimizing --> C \n");
    printf("Index = %d \n", Index);

    Xprmt[P_C]       = parms[P_C];
    X_opt[Index - 1] = Xprmt[P_C];
  } else {
    sl_10 = FALSE;
  }
}

void cb_sa11(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_11 = TRUE;
    Index++;

    printf("Optimizing --> X1 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_X_1]     = parms[P_X_1];
    X_opt[Index - 1] = Xprmt[P_X_1];
  } else {
    sl_11 = FALSE;
  }
}

void cb_sa12(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_12 = TRUE;
    Index++;

    printf("Optimizing --> Y1 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_Y_1]     = parms[P_Y_1];
    X_opt[Index - 1] = Xprmt[P_Y_1];
  } else {
    sl_12 = FALSE;
  }
}

void cb_sa13(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_13 = TRUE;
    Index++;

    printf("Optimizing --> X2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_X_2]     = parms[P_X_2];
    X_opt[Index - 1] = Xprmt[P_X_2];
  } else {
    sl_13 = FALSE;
  }
}

void cb_sa14(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_14 = TRUE;
    Index++;

    printf("Optimizing --> Y2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_Y_2]     = parms[P_Y_2];
    X_opt[Index - 1] = Xprmt[P_Y_2];
  } else {
    sl_14 = FALSE;
  }
}

void cb_sa15(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_15 = TRUE;
    Index++;

    printf("Optimizing --> M1 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_M_1]     = parms[P_M_1];
    X_opt[Index - 1] = Xprmt[P_M_1];
  } else {
    sl_15 = FALSE;
  }
}

void cb_sa16(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_16 = TRUE;
    Index++;
    
    printf("Optimizing --> M2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_M_2]     = parms[P_M_2];
    X_opt[Index - 1] = Xprmt[P_M_2];
  } else {
    sl_16 = FALSE;
  }
}

void cb_sa17(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_17 = TRUE;
    Index++;

    printf("Optimizing --> beta \n");
    printf("Index = %d \n", Index);

    Xprmt[P_BETA]    = parms[P_BETA];
    X_opt[Index - 1] = Xprmt[P_BETA];
  } else {
    sl_17 = FALSE;
  }
}

void cb_sa18(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_18 = TRUE;
    Index++;

    printf("Optimizing --> gamma2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_GAMMA2]  = parms[P_GAMMA2];
    X_opt[Index - 1] = Xprmt[P_GAMMA2];
  } else {
    sl_18 = FALSE;
  }
}

void cb_sa19(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_19 = TRUE;
    Index++;

    printf("Optimizing --> sigma2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_SIGMA2]  = parms[P_SIGMA2];
    X_opt[Index - 1] = Xprmt[P_SIGMA2];
  } else {
    sl_19 = FALSE;
  }
}

void cb_sa20(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_20 = TRUE;
    Index++;

    printf("Optimizing --> phi2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_PHI2]    = parms[P_PHI2];
    X_opt[Index - 1] = Xprmt[P_PHI2];
  } else {
    sl_20 = FALSE;
  }
}

void cb_sa21(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_21 = TRUE;
    Index++;

    printf("Optimizing --> Sx \n");
    printf("Index = %d \n", Index);

    Xprmt[P_SX]      = parms[P_SX];
    X_opt[Index - 1] = Xprmt[P_SX];
  } else {
    sl_21 = FALSE;
  }
}

void cb_sa22(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_22 = TRUE;
    Index++;

    printf("Optimizing --> Sy \n");
    printf("Index = %d \n", Index);

    Xprmt[P_SY]      = parms[P_SY];
    X_opt[Index - 1] = Xprmt[P_SY];
  } else {
    sl_22 = FALSE;
  }
}

void cb_sa23(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_23 = TRUE;
    Index++;

    printf("Optimizing --> alpha \n");
    printf("Index = %d \n", Index);

    Xprmt[P_ALPHA] = parms[P_ALPHA];
    X_opt[Index - 1] = Xprmt[P_ALPHA];
  } else {
    sl_23 = FALSE;
  }
}

void cb_sa24(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_24 = TRUE;
    Index++;

    printf("Optimizing --> alpha2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_ALPHA2]  = parms[P_ALPHA2];
    X_opt[Index - 1] = Xprmt[P_ALPHA2];
  } else {
    sl_24 = FALSE;
  }
}

void cb_sa25(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_25 = TRUE;
    Index++;

    printf("Optimizing --> alpha3 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_ALPHA3]  = parms[P_ALPHA3];
    X_opt[Index - 1] = Xprmt[P_ALPHA3];
  } else {
    sl_25 = FALSE;
  }
}

void cb_sa26(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_26 = TRUE;
    Index++;

    printf("Optimizing --> beta2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_EXP]     = parms[P_EXP];
    X_opt[Index - 1] = Xprmt[P_EXP];
  } else {
    sl_26 = FALSE;
  }
}

void cb_sa27(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_27 = TRUE;
    Index++;

    printf("Optimizing --> kappa2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_KAPPA2]  = parms[P_KAPPA2];
    X_opt[Index - 1] = Xprmt[P_KAPPA2];
  } else {
    sl_27 = FALSE;
  }
}

void cb_sa28(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_28 = TRUE;
    Index++;

    printf("Optimizing --> Ri \n");
    printf("Index = %d \n", Index);

    Xprmt[P_Ri]      = parms[P_Ri];
    X_opt[Index - 1] = Xprmt[P_Ri];
  } else {
    sl_28 = FALSE;
  }
}

void cb_sa29(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_29 = TRUE;
    Index++;

    printf("Optimizing --> Ro \n");
    printf("Index = %d \n", Index);

    Xprmt[P_Ro]      = parms[P_Ro];
    X_opt[Index - 1] = Xprmt[P_Ro];
  } else {
    sl_29 = FALSE;
  }
}

void cb_sa30(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_30 = TRUE;
    Index++;

    printf("Optimizing --> K \n");
    printf("Index = %d \n", Index);

    Xprmt[P_Ko]      = parms[P_Ko];
    X_opt[Index - 1] = Xprmt[P_Ko];
  } else {
    sl_30 = FALSE;
  }
}

void cb_sa31(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_31 = TRUE;
    Index++;

    printf("Optimizing --> kappa0 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_KAPPA0]  = parms[P_KAPPA0];
    X_opt[Index - 1] = Xprmt[P_KAPPA0];
  } else {
    sl_31 = FALSE;
  }
}

void cb_sa32(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_32 = TRUE;
    Index++;

    printf("Optimizing --> Dx \n");
    printf("Index = %d \n", Index);
    
    Xprmt[P_DX_QP]   = parms[P_DX_QP];
    X_opt[Index - 1] = Xprmt[P_DX_QP];
  } else {
    sl_32 = FALSE;
  }
}

void cb_sa33(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_33 = TRUE;
    Index++;

    printf("Optimizing --> Dy \n");
    printf("Index = %d \n", Index);

    Xprmt[P_DY_QP]   = parms[P_DY_QP];
    X_opt[Index - 1] = Xprmt[P_DY_QP];
  } else {
    sl_33 = FALSE;
  }
}

void cb_sa34(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_34 = TRUE;
    Index++;

    printf("Optimizing --> Qxx \n");
    printf("Index = %d \n", Index);

    Xprmt[P_QXX]     = parms[P_QXX];
    X_opt[Index - 1] = Xprmt[P_QXX];
  } else {
    sl_34 = FALSE;
  }
}

void cb_sa35(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_35 = TRUE;
    Index++;
    
    printf("Optimizing --> Qxy \n");
    printf("Index = %d \n", Index);

    Xprmt[P_QXY]     = parms[P_QXY];
    X_opt[Index - 1] = Xprmt[P_QXY];
  } else {
    sl_35 = FALSE;
  }
}

void cb_sa36(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_36 = TRUE;
    Index++;

    printf("Optimizing --> Qyy \n");
    printf("Index = %d \n", Index);

    Xprmt[P_QYY]     = parms[P_QYY];
    X_opt[Index - 1] = Xprmt[P_QYY];
  } else {
    sl_36 = FALSE;
  }
}

void cb_sa37(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_37 = TRUE;
    Index++;

    printf("Optimizing --> thetai \n");
    printf("Index = %d \n", Index);
 
    Xprmt[P_THETA_INC] = parms[P_THETA_INC];
    X_opt[Index - 1]   = Xprmt[P_THETA_INC];
  } else {
    sl_37 = FALSE;
  }
}

void cb_sa38(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_38 = TRUE;
    Index++;

    printf("Optimizing --> q3 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_Q3]      = parms[P_Q3];
    X_opt[Index - 1] = Xprmt[P_Q3];
  } else {
    sl_38 = FALSE;
  }
}

void cb_sa39(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_39 = TRUE;
    Index++;

    printf("Optimizing --> epsilon2 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_EPSILON2] = parms[P_EPSILON2];
    X_opt[Index - 1]  = Xprmt[P_EPSILON2];
  } else {
    sl_39 = FALSE;
  }
}

void cb_sa40(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  if(fl_get_button(ob) && sl_opt == TRUE) {
    sl_40 = TRUE;
    Index++;

    printf("Optimizing --> epsilon3 \n");
    printf("Index = %d \n", Index);

    Xprmt[P_EPSILON3] = parms[P_EPSILON3];
    X_opt[Index - 1]  = Xprmt[P_EPSILON3];
  } else {
    sl_40 = FALSE;
  }
}

/*
    
  sl_1  = FALSE;
  sl_2  = FALSE;
  sl_3  = FALSE;
  sl_4  = FALSE;
  sl_5  = FALSE;
  sl_6  = FALSE;
  sl_7  = FALSE;
  sl_8  = FALSE;
  sl_9  = FALSE;
  sl_10 = FALSE;
  sl_11 = FALSE;
  sl_12 = FALSE;
  sl_13 = FALSE;
  sl_14 = FALSE;
  sl_15 = FALSE;
  sl_16 = FALSE;
  sl_17 = FALSE;
  sl_18 = FALSE;
  sl_19 = FALSE;
  sl_20 = FALSE;
  sl_21 = FALSE;
  sl_22 = FALSE;
  sl_23 = FALSE;
  sl_24 = FALSE;
  sl_25 = FALSE;
  sl_26 = FALSE;
  sl_27 = FALSE;
  sl_28 = FALSE;
  sl_29 = FALSE;
  sl_30 = FALSE;
  sl_31 = FALSE;
  sl_32 = FALSE;
  sl_33 = FALSE;
  sl_34 = FALSE;
  sl_35 = FALSE;
  sl_36 = FALSE;
  sl_37 = FALSE;
  sl_38 = FALSE;
  sl_39 = FALSE;
  sl_40 = FALSE;

**/

void cb_track(FL_OBJECT *ob, long data)
{
  Track = create_form_track();
  
  if(fl_mouse_button())
    fl_show_form(Track->tracks, FL_PLACE_MOUSE|FL_FREE_SIZE, border2, 
		 "Track Window");

  fl_deactivate_object(GLcp->track);
}

void done_track(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_hide_form(Track->tracks);
  fl_activate_object(GLcp->track);
}

void set_inpt(FL_OBJECT *ob, long data)
{
  A_X = fl_get_slider_value(Track->AX);
  A_Y = fl_get_slider_value(Track->AY);

  /* printf("Ax = %f, Ay = %f \n", A_X_i, A_X_f); */
}

void set_fipt(FL_OBJECT *ob, long data)
{
  B_X = fl_get_slider_value(Track->BX);
  B_Y = fl_get_slider_value(Track->BY);

  /* printf("Bx = %f, By = %f \n", B_Y_i, B_Y_f); */
}

void anim_track(FL_OBJECT *ob, long data)
{
  int n_line, ninit, nfin;

  /* FD_GLcp *main_form = (FD_GLcp *)data; */

  h_line = 0.05;

  ninit  = 0;
  nfin   = 80;
  n_line = ninit;

  x_line = A_X;
  y_line = A_Y;

  if(B_X - A_X != 0.0) {
    mtan = (B_Y - A_Y) / (B_X - A_X);

    h_line = h_line * (A_X > B_X ? - 1.0 : 1.0);

    b_line = A_Y - mtan * A_X;

    while(n_line < nfin) {
      x_line = x_line + h_line;
      y_line = mtan * x_line + b_line;
      
      fl_set_positioner_xvalue(GLcp->source_pos, x_line);
      fl_set_positioner_yvalue(GLcp->source_pos, y_line);
      fl_set_counter_value(GLcp->x_pos, x_line);
      fl_set_counter_value(GLcp->y_pos, y_line);
      
      source_position.x = x_line;      
      source_position.y = y_line;
      
      Y[0] = source_position.x;
      Y[1] = source_position.y;
      
      /* printf("x_line = %f, y_line = %f \n", x_line, y_line); */

      ++n_line;

      /* Refresh */
      
      handle_expose(0, 0);
    }
  } else {
    if(A_X == B_X) {
      while(n_line < nfin) {
	y_line += h_line * (A_Y < B_Y ? 1.0 : - 1.0);

	fl_set_positioner_xvalue(GLcp->source_pos, x_line);
	fl_set_positioner_yvalue(GLcp->source_pos, y_line);
	fl_set_counter_value(GLcp->x_pos, x_line);
	fl_set_counter_value(GLcp->y_pos, y_line);

	source_position.x = x_line;      
	source_position.y = y_line;
	
	Y[0] = source_position.x;
	Y[1] = source_position.y;
	
	++n_line; 

	/* Refresh */
	
	handle_expose(0, 0);
      } 
    }
    
    if(A_Y == B_Y) {
      while(n_line < nfin) {
	x_line += h_line * (A_X < B_X ? 1.0 : - 1.0);

	fl_set_positioner_xvalue(GLcp->source_pos, x_line);
	fl_set_positioner_yvalue(GLcp->source_pos, y_line);
	fl_set_counter_value(GLcp->x_pos, x_line);
	fl_set_counter_value(GLcp->y_pos, y_line);

	source_position.x = x_line;      
	source_position.y = y_line;
	
	Y[0] = source_position.x;
	Y[1] = source_position.y;
	
	++n_line;
	
	/* Refresh */
	
	handle_expose(0, 0);
      } 
    }
  }
}
