#include <math.h>
#include <stdio.h>
#include <string.h>

/*
  
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_rng.h"
#include "/temp/local/frutos/Lentes/gsl-0.7/gsl/gsl_siman.h"

**/

#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_rng.h"
#include "/temp/local/frutos/Lentes/gsl-1.0/gsl/gsl_siman.h"

/* #include "functions_siman.c" */

#include "lens_model_siman.c" 

/*

  Set up parameters for this simulated annealing run 

  N_TRIES:       How many points do we try before stepping 

  ITERS_FIXED_T: How many iterations for each T? 

  STEP_SIZE:     Max step size in random walk 

  K:             Boltzmann constant 

  T_INITIAL:     Initial temperature
  
  MU_T:          Damping factor for temperature

  T_MIN:         Minimal Temperature
  
**/

/* #define N_TRIES         200 */

#define N_TRIES         100	 

/* #define ITERS_FIXED_T  1000 */

#define ITERS_FIXED_T   500 

#define STEP_SIZE         1.0 
#define K                 1.0	
#define T_INITIAL         0.1
#define MU_T              1.005	
#define T_MIN             2.0E-6 

#define Nd               50
#define Nump           1000

/* This is defined in stddef.h */

/* #define NULL             0 */

gsl_siman_params_t parametres = {N_TRIES, ITERS_FIXED_T, STEP_SIZE,
                                 K, T_INITIAL, MU_T, T_MIN};

double Energy(void *xp);
void Step(const gsl_rng * r, void *xp, double step_size);
void Print(void *xp);
double Metric(void *xp, void *yp);
void simulated_annealing(VECN x_insa);
void simulated_annealing2(VEC x_insa);
void minimum_time_delay();
void optimization();

/* Definition of the Energy Function */
  
double Energy(void *xp)
{
  int i, j = 0;
  double *x = (double *) xp;
  double Energy_a = 0.0, Energy_p = 0.0, Energy;

  // double temp_px, temp_py, temp_a; 
  
  /* w_p and w_a are not the weights */
  
  for(i = 0; i < Number_of_images; i++) {
    /* lens_models[current_model](x, i); */

    lens_model_siman(x, i);
  }

  /*
    
  if(x[0] < 0.0 || x[0] > 0.5) {
    Energy_a += pow(10.0, 4.0); 
    Energy_p += pow(10.0, 4.0); 
  } else {    
    if(x[1] < 0.0 || x[1] > 1.0) {
      Energy_a += pow(10.0, 4.0); 
      Energy_p += pow(10.0, 4.0); 
    } else {
      if(x[2] < 0.0) {
        Energy_a += pow(10.0, 4.0); 
        Energy_p += pow(10.0, 4.0); 
      } else {
        if(x[5] < 0.0) {
          Energy_a += pow(10.0, 4.0); 
          Energy_p += pow(10.0, 4.0); 
        } else {
          if(x[6] < 0.0) {
            Energy_a += pow(10.0, 4.0); 
            Energy_p += pow(10.0, 4.0);         
          } else {
            if(x[8] < 0.0 || x[8] > 1.0) {
              Energy_a += pow(10.0, 4.0); 
              Energy_p += pow(10.0, 4.0);         
            } else {
              if(x[9] < 0.0 || x[9] > 1.0) {
                Energy_a += pow(10.0, 4.0); 
                Energy_p += pow(10.0, 4.0);         
              } else {
                for(i = 0; i < Number_of_images; i++) {
                  for(j = 0; j < Number_of_images; j++) {
                    if(i != j) {
                      if(w_p != 0.0) {
                        temp_px = square(Y_x[i] - Y_x[j]);
                        temp_py = square(Y_y[i] - Y_y[j]);
                        
                        Energy_p += (w_p * (temp_px + temp_py)) / Delta_Y2; 
                      } else {
                        Energy_p = 0.0;
                      }
        
                      if(w_a != 0.0) {
                        temp_a = square(M_O[i][j] - M_T[i] / M_T[j]);
                        
                        Energy_a += (w_a * temp_a) / Delta_M2;
                      } else {
                        Energy_a = 0.0;
                      }
                    } else {
                      Energy_p = 0.0;
                      Energy_a = 0.0;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  **/

 /*
                  
  for(i = 0; i < Number_of_images; i++) {
    for(j = 0; j < Number_of_images; j++) {
      if(i != j) {
        if(w_p != 0.0) {
          Energy_p += (w_p * (square(Y_x[i] - Y_x[j])
                              + square(Y_y[i] - Y_y[j]))) / Delta_Y2;
        } else {
          Energy_p = 0.0;
        }
        
        if(w_a != 0.0) {
          Energy_a += (w_a * square(M_O[i][j] - M_T[i] / M_T[j])) / Delta_M2; 
        } else {
          Energy_a = 0.0;
        }
      }       
    }
  }

  **/ 
  
  for(i = 0; i < Number_of_images - 1; i++) {
    if(w_p != 0.0) {
      Energy_p += (w_p * sqrt(square(Y_x[i] - Y_x[i + 1])
                              + square(Y_y[i] - Y_y[i + 1]))) / Delta_Y2;
    } else {
      Energy_p = 0.0;
    }
        
    if(w_a != 0.0) {
      Energy_a += (w_a * square(M_O[i][j] - M_T[i] / M_T[j])) / Delta_M2; 
    } else {
      Energy_a = 0.0;
    }   
  }       

  /* Energy = (Energy_p + Energy_a) / Number_of_images; */

  Energy = (Energy_p + Energy_a); 

  /* printf("Energy = %g\n", Energy); */
  
  return Energy;
}

/* Takes a step for the test function; max distance: step_size.
   The new point is put in xp and returned. */

void Step(const gsl_rng * r, void *xp, double step_size)
{
  /* int i, N_p = N_params + Number_of_params; */

  int i, N_p = N_params; 
  double *old_x = (double *) xp;
  double new_x[N_params];

  for(i = 1; i < N_p; i++) {
    new_x[i] = (2.0 * gsl_rng_uniform(r) - 1.0) * step_size + old_x[i];
  }

  if(sl_1 == FALSE) {   
    new_x[0] = xl;
  }

  /*
    
  if(new_x[0] < - BOUND || new_x[0] > BOUND) {
    new_x[0] = BOUND * (2.0 * gsl_rng_uniform(r) - 1.0);
  }

  **/
  
  if(sl_2 == FALSE) {
    new_x[1] = yl;
  }

  /*
    
  if(new_x[1] < - BOUND || new_x[1] > BOUND) {
    new_x[1] = BOUND * (2.0 * gsl_rng_uniform(r) - 1.0);
  }

  **/
  
  if(sl_3 == FALSE) {
    new_x[2] = parms[P_E];    
  }

  /*
    
  if(new_x[2] < 0.0 || new_x[2] > BOUND) {
    new_x[2] = BOUND * gsl_rng_uniform(r);
  }

  **/
  
  if(sl_4 == FALSE) {
    new_x[3] = parms[P_THETA];        
  }

  /*
    
  if(new_x[3] < - 2.0 * M_PI || new_x[3] > 2.0 * M_PI) {
    new_x[3] = 2.0 * M_PI * (2.0 * gsl_rng_uniform(r) - 1.0);
  }

  **/
  
  if(sl_5 == FALSE) {
    new_x[4] = parms[P_GAMMA];        
  }

  /*
    
  if(new_x[4] >= 1.0) {
    new_x[4] = old_x[4];
  }

  **/
  
  if(sl_6 == FALSE) {
    new_x[5] = parms[P_SIGMA];        
  } 

  /*
    
  if(new_x[5] < 0.0 || new_x[5] >= 1.0) {
    new_x[5] = gsl_rng_uniform(r);
  }

  **/
  
  if(sl_7 == FALSE) {
    new_x[6] = parms[P_PHI];        
  }

  /*
    
  if(new_x[6] < - 2.0 * M_PI || new_x[6] > 2.0 * M_PI) {
    new_x[6] = 2.0 * M_PI * (2.0 * gsl_rng_uniform(r) - 1.0);
  }

  **/
  
  if(sl_8 == FALSE) {  
    new_x[7] = parms[P_KAPPA];        
  }

  /*
    
  if(new_x[7] < 0.0 || new_x[7] > BOUND) {
    new_x[7] = BOUND * gsl_rng_uniform(r);
  }

  **/
  
  if(sl_9 == FALSE) { 
    new_x[8] = parms[P_EPSILON];        
  }

  /*
    
  if(new_x[8] < 0.0 || new_x[8] >= 1.0) {
    new_x[8] = gsl_rng_uniform(r);
  }

  **/
  
  if(sl_10 == FALSE) {
    new_x[9] = parms[P_C];        
  }

  /*
    
  if(new_x[9] < 0.0 || new_x[9] > BOUND) {
    new_x[9] = BOUND * gsl_rng_uniform(r);
  }

  **/
  
  if(sl_11 == FALSE) {
    new_x[10] = parms[P_X_1];        
  }

  if(sl_12 == FALSE) {
    new_x[11] = parms[P_Y_1];        
  }

  if(sl_13 == FALSE) {
    new_x[12] = parms[P_X_2];        
  }

  if(sl_14 == FALSE) {
    new_x[13] = parms[P_X_2];        
  }

  if(sl_15 == FALSE) {
    new_x[14] = parms[P_M_1];        
  }

  if(sl_16 == FALSE) {
    new_x[15] = parms[P_M_2];        
  }

  if(sl_17 == FALSE) {
    new_x[16] = parms[P_BETA];        
  }

  if(sl_18 == FALSE) {
    new_x[17] = parms[P_GAMMA2];        
  }

  if(sl_19 == FALSE) {
    new_x[18] = parms[P_SIGMA2];        
  }

  if(sl_20 == FALSE) {
    new_x[19] = parms[P_PHI2];        
  }

  if(sl_21 == FALSE) {
    new_x[20] = parms[P_SX];        
  }

  if(sl_22 == FALSE) {
    new_x[21] = parms[P_SY];        
  }

  if(sl_23 == FALSE) {
    new_x[22] = parms[P_ALPHA];        
  }

  /*
    
  if(new_x[22] < 0.0 || new_x[22] > 0.5) {
    new_x[22] = 0.5 * gsl_rng_uniform(r);
  }

  **/
  
  if(sl_24 == FALSE) {
    new_x[23] = parms[P_ALPHA2];        
  }

  if(sl_25 == FALSE) {
    new_x[24] = parms[P_EXP];        
  }

  if(sl_26 == FALSE) {
    new_x[25] = parms[P_KAPPA2];  
  }

  if(sl_27 == FALSE) {
    new_x[26] = parms[P_Ri];  
  }

  if(sl_28 == FALSE) {
    new_x[27] = parms[P_Ro];  
  }

  if(sl_29 == FALSE) {
    new_x[28] = parms[P_KAPPA0];  
  }

  if(sl_30 == FALSE) {
    new_x[29] = parms[P_DX_QP];  
  }

  if(sl_31 == FALSE) {
    new_x[30] = parms[P_DY_QP];  
  }

  if(sl_32 == FALSE) {
    new_x[31] = parms[P_QXX];  
  }

  if(sl_33 == FALSE) {
    new_x[32] = parms[P_QXY];  
  }

  if(sl_34 == FALSE) {
    new_x[33] = parms[P_QYY];  
  }

  memcpy(xp, new_x, N_p * sizeof(*new_x));
}

/* Simple routine to print out a position value */

void Print(void *xp)
{
  int i, N_p = N_params; 
  double *x = (double *) xp;

  /* printf("%12g", *x); */
  
  for(i = 0; i < N_p; i++) {
    printf("\n x[%d] = %g\n", i, x[i]);
  } 
}

/* A metric for the Number_of_params X D space */

double Metric(void *xp, void *yp)
{
  int i, N_p = N_params; 
  double *x = (double *) xp;
  double *y = (double *) yp;
  double distance2 = 0;

  for(i = 0; i < N_p; i++) {
    distance2 += square(y[i] - x[i]);
  }
  
  return sqrt(distance2);
}

void simulated_annealing(VECN x_insa)
{
  int N_p = N_params; 

  gsl_rng *r = gsl_rng_alloc(gsl_rng_env_setup());
  
  /* printf("#The Simulated Annealing routines\n"); */       

  /* gsl_siman_solve(r, x_insa, Energy, Step, Metric, Print,
     N_p * sizeof(double), parametres); */

  /* This is for gsl-0.7 */
  
  /* gsl_siman_solve(r, x_insa, Energy, Step, Metric, 0,
     N_p * sizeof(double), parametres); */

  /* This is for gsl-1.0 */
   
  gsl_siman_solve(r, x_insa, Energy, Step, Metric, NULL, NULL, NULL, NULL,
                  N_p * sizeof(double), parametres); 

  gsl_rng_free(r);
}

void simulated_annealing2(VEC x_insa)
{
  gsl_rng *r = gsl_rng_alloc(gsl_rng_env_setup());
  
  /* printf("#The Simulated Annealing routines\n"); */       

  /* gsl_siman_solve(r, x_insa, Energy, Step, Metric, Print,
     Ne * sizeof(double), parametres); */

  /* This is for gsl-0.7 */

  /* gsl_siman_solve(r, x_insa, Energy, Step, Metric, 0, Ne * sizeof(double),
     parametres); */

  /* This is for gsl-1.0 */

  gsl_siman_solve(r, x_insa, Energy, Step, Metric, NULL, NULL, NULL, NULL,
                  Ne * sizeof(double), parametres); 

  gsl_rng_free(r);
}

void minimum_time_delay()
{
  VEC x_insa;

  x_insa[0] = 0.0; 
  x_insa[1] = 0.0;
  
  simulated_annealing2(x_insa);

  draw_point(x_insa[0], x_insa[1], 5.0, 4);
}

void optimization()
{
  int i, N_p = N_params; 

  VECN x_insa;

  x_insa[0]  = xl; 
  x_insa[1]  = yl;
  x_insa[2]  = parms[P_E]; 
  x_insa[3]  = parms[P_THETA];  
  x_insa[4]  = parms[P_GAMMA]; 
  x_insa[5]  = parms[P_SIGMA];
  x_insa[6]  = parms[P_PHI];
  x_insa[7]  = parms[P_KAPPA];
  x_insa[8]  = parms[P_EPSILON];
  x_insa[9]  = parms[P_C];
  x_insa[10] = parms[P_X_1];
  x_insa[11] = parms[P_Y_1];
  x_insa[12] = parms[P_X_2];
  x_insa[13] = parms[P_Y_2];
  x_insa[14] = parms[P_M_1];
  x_insa[15] = parms[P_M_2];
  x_insa[16] = parms[P_BETA];
  x_insa[17] = parms[P_GAMMA2];
  x_insa[18] = parms[P_SIGMA2];
  x_insa[19] = parms[P_PHI2];
  x_insa[20] = parms[P_SX];
  x_insa[21] = parms[P_SY];
  x_insa[22] = parms[P_ALPHA];
  x_insa[23] = parms[P_ALPHA2];
  x_insa[24] = parms[P_EXP];
  x_insa[25] = parms[P_KAPPA2];
  x_insa[26] = parms[P_Ri];
  x_insa[27] = parms[P_Ro];
  x_insa[28] = parms[P_KAPPA0];
  x_insa[29] = parms[P_DX_QP];
  x_insa[30] = parms[P_DY_QP];
  x_insa[31] = parms[P_QXX];
  x_insa[32] = parms[P_QXY];
  x_insa[33] = parms[P_QYY];
  
  simulated_annealing(x_insa);

  xl               = x_insa[0]; 
  yl               = x_insa[1];
  parms[P_E]       = x_insa[2]; 
  parms[P_THETA]   = x_insa[3]; 
  parms[P_GAMMA]   = x_insa[4]; 
  parms[P_SIGMA]   = x_insa[5]; 
  parms[P_PHI]     = x_insa[6];
  parms[P_KAPPA]   = x_insa[7]; 
  parms[P_EPSILON] = x_insa[8]; 
  parms[P_C]       = x_insa[9];
  parms[P_X_1]     = x_insa[10];
  parms[P_Y_1]     = x_insa[11]; 
  parms[P_X_2]     = x_insa[12]; 
  parms[P_Y_2]     = x_insa[13];
  parms[P_M_1]     = x_insa[14]; 
  parms[P_M_2]     = x_insa[15]; 
  parms[P_BETA]    = x_insa[16]; 
  parms[P_GAMMA2]  = x_insa[17]; 
  parms[P_SIGMA2]  = x_insa[18]; 
  parms[P_PHI2]    = x_insa[19]; 
  parms[P_SX]      = x_insa[20]; 
  parms[P_SY]      = x_insa[21];
  parms[P_ALPHA]   = x_insa[22];
  parms[P_ALPHA2]  = x_insa[23]; 
  parms[P_EXP]     = x_insa[24];
  parms[P_KAPPA2]  = x_insa[25]; 
  parms[P_Ri]      = x_insa[26];
  parms[P_Ro]      = x_insa[27];
  parms[P_KAPPA0]  = x_insa[28]; 
  parms[P_DX_QP]   = x_insa[29]; 
  parms[P_DY_QP]   = x_insa[30]; 
  parms[P_QXX]     = x_insa[31]; 
  parms[P_QXY]     = x_insa[32]; 
  parms[P_QYY]     = x_insa[33]; 
      
  for(i = 0; i < N_p; i++) {    
    printf("X_sa[%d] = %g\n", i, x_insa[i]);
  }

  printf("X_sa[3] = %g\n", (180.0 * x_insa[3] / M_PI));
  printf("X_sa[6] = %g\n", (180.0 * x_insa[6] / M_PI));
}

