#include <math.h>
#include <stdio.h>
#include <string.h>

void lens_model_siman(double *x, int i);

void lens_model_siman(double *x, int i)
{
  double xbar0 = 0.0, xbar1 = 0.0, alpha0 = 0.0, alpha1 = 0.0;

  /* double radius_E, radius_E2, radius_E3, radius_E4; */

  double radius_E, radius_E2, radius_E4; 

  double Mkaprp, Mkapto, rbeta, rs12, xd1, xd2, yp1, yp2, rd2, s2;
  double poly1, poly2, poly3, poly4, poly5, poly6, poly7;
  double funcnis, functs,func1, func2, func3, funchb, funcs, funcrl;
  double dipolm1, dipolm2, quadrupolm1, quadrupolm2; 
  double Epsilon1, Epsilon2, delta, delta2;

  double x0 = x_obs[i];
  double x1 = y_obs[i];

  switch(SIM_AN) {
  case FALSE:
    break;
  case TRUE:
    if(sl_1 == FALSE) {
      Prmt[0] = xl;
    } else {
      Prmt[0] = x[0];        
    }

    if(sl_2 == FALSE) {
      Prmt[1] = yl;
    } else {
      Prmt[1] = x[1];        
    }

    if(sl_3 == FALSE) {
      Prmt[2] = parms[P_E];
    } else {
      Prmt[2] = x[2];        
    }

    if(sl_4 == FALSE) {
      Prmt[3] = parms[P_THETA];
    } else {
      Prmt[3] = x[3];        
    }

    if(sl_5 == FALSE) {
      Prmt[4] = parms[P_GAMMA];
    } else {
      Prmt[4] = x[4];        
    }

    if(sl_6 == FALSE) {
      Prmt[5] = parms[P_SIGMA];
    } else {
      Prmt[5] = x[5];        
    }

    if(sl_7 == FALSE) {
      Prmt[6] = parms[P_PHI];
    } else {
      Prmt[6] = x[6];        
    }

    E_rad  = Prmt[2];
    E2_rad = E_rad * E_rad;
    E3_rad = E_rad * E2_rad;
    E4_rad = E_rad * E3_rad;

    CS = cos(Prmt[3]);
    SS = sin(Prmt[3]);

    B1 = 1.0 - Prmt[5] - Prmt[4] * cos(Prmt[6]);
    B2 = 1.0 - Prmt[5] + Prmt[4] * cos(Prmt[6]);
    B3 =               - Prmt[4] * sin(Prmt[6]);

    xbar0 =   x0 * CS + x1 * SS;
    xbar1 = - x0 * SS + x1 * CS;
    
    switch(current_model) {
    case M_CHANG_REFSDAL:
      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
  
      alpha0 = xbar0 / radius_E2;
      alpha1 = xbar1 / radius_E2;

      break;   
    case M_SING_ISOT_SPHERE:
      if(sl_25 == FALSE) {
        Prmt[24] = parms[P_EXP];
      } else {
        Prmt[24] = x[24];        
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);

      rbeta = pow(radius_E, Prmt[24] - 1.0);
    
      alpha0 = rbeta * xbar0;
      alpha1 = rbeta * xbar1;  

      break;
    case M_NSING_ISOT_SPHERE:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];        
      }

      if(sl_10 == FALSE) {
        Prmt[9] = parms[P_C];
      } else {
        Prmt[9] = x[9];        
      }

      radius_E2 = xbar0 * xbar0 + xbar1 * xbar1;

      s2 = (Prmt[9] * Prmt[9] + radius_E2) / E2_rad;
    
      funcnis = sqrt(s2) - Prmt[9] / Prmt[2];

      alpha0 = (Prmt[7] * funcnis * xbar0) / radius_E2;
      alpha1 = (Prmt[7] * funcnis * xbar1) / radius_E2;

      break;
    case M_TRANSP_SPHERE:
      if(sl_10 == FALSE) {
        Prmt[9] = parms[P_C];
      } else {
        Prmt[9] = x[9];        
      }

      radius_E2 = xbar0 * xbar0 + xbar1 * xbar1;
      radius_E  = sqrt(radius_E2);

      s2 = 1.0 - radius_E2 / (Prmt[9] * Prmt[9]);

      functs = 1.0 - pow(s2, (3.0 / 2.0));

      if(Prmt[9] > radius_E){
        alpha0 = (functs * xbar0) / (radius_E2 / E2_rad);
        alpha1 = (functs * xbar1) / (radius_E2 / E2_rad);    
      } else {
        alpha0 = xbar0 / (radius_E2 / E2_rad);
        alpha1 = xbar1 / (radius_E2 / E2_rad); 
      }   

      break;
    case M_ELLIPTICAL:
      if(sl_8 == FALSE) {
        Prmt[7]  = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];        
      }
      
      if(sl_9 == FALSE) {
        Prmt[8] = parms[P_EPSILON];
      } else {
        Prmt[8] = x[8];        
      }

      if(sl_10 == FALSE) {
        Prmt[9] = parms[P_C];
      } else {
        Prmt[9] = x[9];        
      }

      if(sl_23 == FALSE) {
        Prmt[22] = parms[P_ALPHA];
      } else {
        Prmt[22] = x[22];        
      }

      Epsilon1 = 1.0 - Prmt[8];
      Epsilon2 = 1.0 + Prmt[8];

      delta  = Prmt[22] - 1.0;
      delta2 = 2.0 * Prmt[22];

      s2 = (Prmt[9] * Prmt[9]
            + Epsilon1 * xbar0 * xbar0 + Epsilon2 * xbar1 * xbar1) / E2_rad;
  
      alpha0 = (Prmt[7] * Epsilon1 * xbar0
                * pow(s2, delta)) / pow(Prmt[9], delta2);
      alpha1 = (Prmt[7] * Epsilon2 * xbar1
                * pow(s2, delta)) / pow(Prmt[9], delta2);  

      break;
    case M_KING:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

      alpha0 = (Prmt[7] * xbar0 * log1p(radius_E2)) / radius_E2;
      alpha1 = (Prmt[7] * xbar1 * log1p(radius_E2)) / radius_E2;

      break;
    case M_TRUNC_KING:
      if(sl_10 == FALSE) {
        Prmt[9] = parms[P_C];     
      } else {
        Prmt[9] = x[9];        
      }

      if(sl_26 == FALSE) {
        Prmt[25] = parms[P_KAPPA2];
      } else {
        Prmt[25] = x[25];        
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);

      func1 = log1p(radius_E2) + radius_E2 / (1.0
                                              + (Prmt[9] * Prmt[9]) / E2_rad); 
      func2 = (4.0 * (hypot(1.0, radius_E)
                      - 1.0)) / hypot(1.0, Prmt[9] / E_rad);
      func3 = func1 - func2;
  
      alpha0 = (Prmt[25] * xbar0 * func3) / radius_E2; 
      alpha1 = (Prmt[25] * xbar1 * func3) / radius_E2;

      break;
    case M_HUBBLE:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);
  
      funchb = log1p(radius_E) - radius_E / (1.0 + radius_E);

      alpha0 = (2.0 * Prmt[7] * xbar0 * funchb) / radius_E2;
      alpha1 = (2.0 * Prmt[7] * xbar1 * funchb) / radius_E2;  

      break;
    case M_DE_VAUCOULEUR:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);
 
      poly1 = 720.0 / tau8 + (720.0 * pow(radius_E, (1.0 / 4.0))) / tau7;
      poly2 = poly1 + pow(radius_E, (3.0 / 2.0)) / tau2;
      poly3 = poly2 + (6.0 * pow(radius_E, (5.0 / 4.0))) / tau3;
      poly4 = poly3 + (30.0 * radius_E) / tau4;
      poly5 = poly4 + (120.0 * pow(radius_E, (3.0 / 4.0))) / tau5;
      poly6 = poly5 + (360.0 * sqrt(radius_E)) / tau6;
      poly7 = 7.0 * poly6 + pow(radius_E, (7.0 / 4.0)) / tau;

      func1 = poly7 * exp(- tau * (pow(radius_E, (1.0 / 4.0)) - 1.0));
      func2 = func1 - (5040.0 * Ftau) / tau8;

      alpha0 = - (8.0 * Prmt[7] * xbar0 * func2) / radius_E2;
      alpha1 = - (8.0 * Prmt[7] * xbar1 * func2) / radius_E2;

      break;
    case M_SPIRAL:
      if(sl_8 == FALSE) {
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_24 == FALSE) {
        Prmt[23] = parms[P_ALPHA2];
      } else {
        Prmt[23] = x[23];       
      } 

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);

      funcs = 2.0 * Prmt[7] * (1.0 - exp(- Prmt[23] * radius_E)
                               * (Prmt[23] * radius_E + 1.0));

      alpha0 = (funcs * xbar0) / (Prmt[23] * Prmt[23] * radius_E2);
      alpha1 = (funcs * xbar1) / (Prmt[23] * Prmt[23] * radius_E2);  

      break;
    case M_MULTIPOLE:
      if(sl_29 == FALSE) {
        Prmt[28] = parms[P_KAPPA0];
      } else {
        Prmt[28] = x[28];       
      }

      if(sl_30 == FALSE) {
        Prmt[29] = parms[P_DX_QP];
      } else {
        Prmt[29] = x[29];       
      }
      
      if(sl_31 == FALSE) {  
        Prmt[30] = parms[P_DY_QP];
      } else {
        Prmt[30] = x[30];       
      }

      if(sl_32 == FALSE) {  
        Prmt[31] = parms[P_QXX];
      } else {
        Prmt[31] = x[31];       
      }

      if(sl_33 == FALSE) {  
        Prmt[32] = parms[P_QXY];
      } else {
        Prmt[32] = x[32];       
      }

      if(sl_34 == FALSE) {  
        Prmt[33] = parms[P_QYY];
      } else {
        Prmt[33] = x[33];       
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E4 = radius_E2 * radius_E2;

      dipolm1 = E3_rad * (Prmt[29] * (xbar1 * xbar1 - xbar0 * xbar0)
                          - 2.0 * Prmt[30] * xbar0 *
                          xbar1) / pow((xbar0 * xbar0 + xbar1 * xbar1), 2.0);
    
      dipolm2 = - E3_rad * (Prmt[30] * (xbar1 * xbar1 - xbar0 * xbar0)
                            + 2.0 * Prmt[29] * xbar0 *
                            xbar1) / pow((xbar0 * xbar0 + xbar1 * xbar1), 2.0);

      quadrupolm1 = 2.0 * E4_rad * (Prmt[31] * xbar0 *
                                    (3.0 * xbar1 * xbar1 - xbar0 * xbar0)
                                    + Prmt[32] * xbar1 *
                                    (xbar1 * xbar1 - 3.0 * xbar0 * xbar0)) /
        pow((xbar0 * xbar0 + xbar1 * xbar1), 3.0);

      quadrupolm2 = 2.0 * E4_rad * (Prmt[33] * xbar1 *
                                    (3.0 * xbar0 * xbar0 - xbar1 * xbar1)
                                    + Prmt[32] * xbar0 *
                                    (xbar0 * xbar0 - 3.0 * xbar1 * xbar1)) /
        pow((xbar0 * xbar0 + xbar1 * xbar1), 3.0);
    
      alpha0 = (Prmt[28] * xbar0) / radius_E2 + dipolm1 + quadrupolm1; 
      alpha1 = (Prmt[28] * xbar1) / radius_E2 + dipolm2 + quadrupolm2;

      break;
    case M_ROTATION_LENS:
      if(sl_21 == FALSE) {  
        Prmt[20] = parms[P_SX];
      } else {
        Prmt[20] = x[20];       
      }

      if(sl_22 == FALSE) {  
        Prmt[21] = parms[P_SY];
      } else {
        Prmt[21] = x[21];       
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E4 = radius_E2 * radius_E2;

      funcrl = (Prmt[20] * xbar1 - Prmt[21] * xbar0) / E_rad;

      alpha0 = xbar0 / radius_E2 + (2.0 * funcrl * xbar0) / radius_E4
        + Prmt[21] / (E_rad * radius_E2);
      alpha1 = xbar1 / radius_E2 + (2.0 * funcrl * xbar1) / radius_E4
        - Prmt[20] / (E_rad * radius_E2);
      
      break;
    case M_DOUBLE_LENS:
      if(sl_11 == FALSE) {  
        Prmt[10]  = parms[P_X_1];
      } else {
        Prmt[10] = x[10];       
      }

      if(sl_12 == FALSE) {  
        Prmt[11]  = parms[P_Y_1];
      } else {
        Prmt[11] = x[11];       
      }

      if(sl_13 == FALSE) {  
        Prmt[12]  = parms[P_X_2];
      } else {
        Prmt[12] = x[12];       
      }

      if(sl_14 == FALSE) {  
        Prmt[13] = parms[P_Y_2];      
      } else {
        Prmt[13] = x[13];       
      }

      if(sl_15 == FALSE) {  
        Prmt[14] = parms[P_M_1];
      } else {
        Prmt[14] = x[14];       
      }

      if(sl_16 == FALSE) {  
        Prmt[15] = parms[P_M_2];
      } else {
        Prmt[15] = x[15];       
      }

      if(sl_17 == FALSE) {  
        Prmt[16] = parms[P_BETA];
      } else {
        Prmt[16] = x[16];       
      }

      if(sl_18 == FALSE) {  
        Prmt[17] = parms[P_GAMMA2];
      } else {
        Prmt[17] = x[17];       
      }

      if(sl_19 == FALSE) {  
        Prmt[18] = parms[P_SIGMA2];
      } else {
        Prmt[18] = x[18];       
      }

      if(sl_20 == FALSE) {  
        Prmt[19] = parms[P_PHI2];
      } else {
        Prmt[19] = x[19];       
      }

      C1 = 1.0 - Prmt[18] - Prmt[17] * cos(Prmt[19]);
      C2 = 1.0 - Prmt[18] + Prmt[17] * cos(Prmt[19]);
      C3 =                - Prmt[17] * sin(Prmt[19]);

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;

      rs12 = ((xbar0 - Prmt[10]) * (xbar0 - Prmt[10])
              + (xbar1 - Prmt[11]) * (xbar1 - Prmt[11])) / E2_rad;

      yp1 = C1 * xbar0 + C3 * xbar1;
      yp2 = C2 * xbar1 + C3 * xbar0; 
  
      xd1 = yp1 - Prmt[14] * Prmt[16] * (xbar0 - Prmt[10]) / rs12; 
      xd2 = yp2 - Prmt[14] * Prmt[16] * (xbar1 - Prmt[11]) / rs12; 

      rd2 = ((xd1 - Prmt[12]) * (xd1 - Prmt[12])
             + (xd2 - Prmt[13]) * (xd2 - Prmt[13])) / E2_rad;

      alpha0 = Prmt[14] * (xbar0 - Prmt[10]) / rs12
        + Prmt[15] * (xd1 - Prmt[12]) / rd2;  
      alpha1 = Prmt[14] * (xbar1 - Prmt[11]) / rs12
        + Prmt[15] * (xd2 - Prmt[13]) / rd2;          

      break;
    case M_UNIFORM_RING:
      if(sl_8 == FALSE) {  
        Prmt[7] = parms[P_KAPPA];
      } else {
        Prmt[7] = x[7];       
      }

      if(sl_27 == FALSE) {  
        Prmt[26] = parms[P_Ri];
              } else {
        Prmt[26] = x[26];       
      }

      if(sl_28 == FALSE) {  
        Prmt[27] = parms[P_Ro];
      } else {
        Prmt[27] = x[27];       
      }

      radius_E2 = (xbar0 * xbar0 + xbar1 * xbar1) / E2_rad;
      radius_E  = sqrt(radius_E2);
  
      Mkaprp = 10.0 * Prmt[7] * (radius_E2 - Prmt[26] * Prmt[26]);
      Mkapto = 10.0 * Prmt[7] * (Prmt[27] * Prmt[27] - Prmt[26] * Prmt[26]);
  
      if(radius_E >= Prmt[27]) {
        alpha0 = (Mkapto * xbar0) / radius_E2;
        alpha1 = (Mkapto * xbar1) / radius_E2; 	     
      } else {
        if(radius_E >= Prmt[26]) {
          alpha0 = (Mkaprp * xbar0) / radius_E2;
          alpha1 = (Mkaprp * xbar1) / radius_E2; 	
        } else {
          alpha0 = 0.0;
          alpha1 = 0.0; 
        }   
      }

      break; 
    }   

    Y_x[i] = B1 * xbar0 + B3 * xbar1 - alpha0 + Prmt[0];    
    Y_y[i] = B2 * xbar1 + B3 * xbar0 - alpha1 + Prmt[1];

    break;
  }
}
