#include <math.h>
#include <stdlib.h>

#include <GL/glu.h> 

/* #include </home/frutos/glut-3.7/include/GL/glut.h> */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "glxf.h"

// #include "Imlib.h"

#include <Imlib.h> 

#include "forms.h"
#include "forms_gl.c"

// #include "glform_cb.c"
// #include "glform.c"

#include "glform_new.c"
#include "gl_models.c"
#include "caustic.c"

// #include "caustic_contour.c"

/* #include </temp/local/frutos/Lentes/imlib-1.9.8/Imlib/Imlib.h> */

/* #include "Imlib2.h" */

/* Model Parametres 
   
   P_E,                1.5         
   P_THETA,            0.0         
   P_GAMMA,            0.05        
   P_SIGMA,            0.05        
   P_PHI,              0.0         
   P_R,                0.1         
   P_KAPPA,            1.0        
   P_KAPPA2,           5.0         
   P_EXP,              1.0         
   P_C,                1.0         
   P_XT,               1.0        
   P_EPSILON,          0.4         
   P_EPSILON2,         0.4        
   P_EPSILON3,         0.4        
   P_ALPHA,            0.2          
   P_ALPHA2,           1.0          
   P_ALPHA3,           0.2         
   P_KAPPA0,           1.0         
   P_DX_QP,            0.5         
   P_DY_QP,            0.5        
   P_QXX,              0.1         
   P_QXY,              0.0         
   P_QYY,            - 0.1       
   P_M_1,              0.5         
   P_X_1,              0.0         
   P_Y_1,              0.0         
   P_BETA,             1.0         
   P_GAMMA2,           0.05        
   P_SIGMA2,           0.05        
   P_PHI2,             0.0         
   P_M_2,              0.5        
   P_X_2,              0.0         
   P_Y_2,              0.0         
   P_SX,               0.5         
   P_SY,               0.5        
   P_Ri,               1.0         
   P_Ro,               2.0         
   P_Ko,               1.0           
   P_Q3,               0.5          
   P_Theta_INC         0.0         
   
**/
   
GL_parms parms[] = {1.5, 0.0, 0.05, 0.05, 0.0, 0.1, 1.0, 5.0, 1.0, 1.0, 1.0,
		    0.4, 0.4, 0.4, 0.2, 1.0, 0.2, 1.0, 0.5, 0.5, 0.1, 0.0, 
                    - 0.1, 0.5, 0.0, 0.0, 1.0, 0.05, 0.05, 0.0, 0.5, 0.0, 0.0,
		    0.5, 0.5, 1.0, 2.0, 1.0, 0.5, 0.0}; 
                    
GL_pos source_position = {0.0, 0.0};

long switches = 0;
int precision = 4;

int current_model   = 0;
int source_figure   = 0;
int current_save    = 0;
int current_swept   = 0;
int current_method  = 0;
int current_caustic = 0;

Model models[] =
{
  model_menu,
  chang_refsdal,
  singular_isothermal_sphere,
  nonsingular_isothermal_sphere,
  transparent_sphere,
  elliptical,
  king,
  truncated_king,
  hubble,
  de_vaucouleur,
  spiral,
  multipole,
  rotation_lens,
  double_lens,
  uniform_ring,
  second_order, 
  Elliptical_SIS_KK, 
  Elliptic_King, 
  Elliptic_Hubble, 
  Elliptic_NIS, 
  Elliptic_Plummer, 
  Elliptic_KK,
  Navarro_Frenk_White,
  Barkana 
};

/*
  
Lens_Model lens_models[] =
{
  model_menu_siman,
  chang_refsdal_siman,
  singular_isothermal_sphere_siman,
  nonsingular_isothermal_sphere_siman,
  transparent_sphere_siman,
  elliptical_siman,
  king_siman,
  truncated_king_siman,
  hubble_siman,
  de_vaucouleur_siman,
  spiral_siman,
  multipole_siman,
  rotation_lens_siman,
  double_lens_siman,
  uniform_ring_siman
};

**/

// #include "gsl_rootfinder.c"
// #include "gsl_simulated_annealing.c"

#include "Brent.c"

// #include "lens_model_praxis.c"
// #include "choice.c"
// #include "Praxis.c"

#include "lens_model_opt.c"
#include "Evolution_new.c"

// #include "Simplex_new.c"

Window GLwin;

FD_GLcp *GLcp;

ImlibData *id;
ImlibImage *im;

// #include "glform_cb.c" 

#include "glform_cb_new.c" 

// #include "Niveau.c"
// #include "glnncntr.c"

#include "Aramini.c"
#include "Potential.c"

// #include "Aramini2.c"

/*
  
void Circle(float r, int color);
void Circle(float r);
void colormap(float, float, GLfloat *);
void colormap_s(float, float, GLfloat *);
void Con_Circ();
void Con_Ellip();
void color_point(int i);
void draw_circle(double x, double y, double rad);
void draw_data(void);
void draw_grid(void);
void draw_invert(void);
void draw_images(void);
void draw_point(double x, double y, double rad);
void draw_photo(void);
void draw_photo_invert(void);
void draw_rplot(void);
void draw_ring(double x, double y, double radi double rado)
void draw_source(double r);
void Ellipse(float a, float b);
int handle_expose(XEvent *event, void *data);
void initialize();
void Spiral(double ctm);

**/

/* int main(int argc, char *argv[]) */

// double pars[Ne];

int main(int argc, char **argv) 
{
  FL_OBJECT *ob;

  GLXContext context;

  int config[] = {GLX_RGBA, GLX_DOUBLEBUFFER, None};
  
  initialize();

  fl_initialize(&argc, argv, "GL Control Panel", 0, 0);
  
  GLcp = create_form_GLcp();
  
  /*

  fl_set_input_maxchars(GLcp->imp_x, 8);
  fl_set_input_maxchars(GLcp->imp_y, 8);
 
   */

  if(!(GLwin = fl_glwincreate(config, &context, Mwin, Nwin))) {
    fprintf(stderr, "GLWin: Can't create OpenGL window \n"); 
    exit(0); 
  }  
  
  fl_winaspect(GLwin, Nwin, Mwin);
  fl_wintitle(GLwin, "Image Window");
  fl_add_event_callback(GLwin, Expose, handle_expose, 0);
  fl_set_cursor(GLwin, XC_crosshair);
    
  // gluOrtho2D(- BOUND, BOUND, - BOUND, BOUND); 

  /*

  glutInit(&argc, argv);
  glutKeyboardFunc(keyboard); 
  glutMouseFunc(mouse); 
  glutMainLoop(); 

  **/

  /* glOrtho(- BOUND, BOUND, - BOUND, BOUND,- BOUND, BOUND); */ 

  /*

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); 

  **/

  fl_hide_object(GLcp->p_E);
  fl_hide_object(GLcp->p_theta);
  fl_hide_object(GLcp->p_gamma);
  fl_hide_object(GLcp->p_sigma);
  fl_hide_object(GLcp->p_phi);
  fl_hide_object(GLcp->p_R);
  fl_hide_object(GLcp->p_C);  
  fl_hide_object(GLcp->p_xt);  
  fl_hide_object(GLcp->p_elliptical_model);
  fl_hide_object(GLcp->p_elliptical_kk);
  fl_hide_object(GLcp->p_quadrupole_model);
  fl_hide_object(GLcp->p_rotationlens_model);
  fl_hide_object(GLcp->p_doublelens_model);
  fl_hide_object(GLcp->p_kappa);
  fl_hide_object(GLcp->p_kappa2);
  fl_hide_object(GLcp->p_alpha);
  fl_hide_object(GLcp->p_alpha2);
  fl_hide_object(GLcp->p_alpha3);
  fl_hide_object(GLcp->p_epsilon);
  fl_hide_object(GLcp->p_epsilon2);
  fl_hide_object(GLcp->p_epsilon3);
  fl_hide_object(GLcp->p_exp);
  fl_hide_object(GLcp->p_ko);
  fl_hide_object(GLcp->p_theta_inc);
  fl_hide_object(GLcp->p_q3);

  /*

  fl_deactivate_object(GLcp->p_C);
  fl_set_object_lcol(GLcp->p_C, FL_INACTIVE_COL); 

  **/

  fl_hide_object(GLcp->p_uniform_ring);

  /*
    
  fl_hide_object(GLcp->p_Ri);
  fl_hide_object(GLcp->p_Ro);
  
  **/

  /*
    
  fl_deactivate_object(GLcp->sources);
  fl_deactivate_object(GLcp->images);

  **/
  
  //  fl_show_form(GLcp->GLcp, FL_PLACE_MOUSE | FL_FREE_SIZE, FL_FULLBORDER,
  //	       "GL Control Panel");


  fl_show_form(GLcp->GLcp, FL_PLACE_ASPECT, FL_FULLBORDER, "GL Control Panel");
  
  // fl_scale_form(GLcp->GLcp, 0.9, 0.8);

  id = Imlib_init(fl_display);
  
  /* fl_redraw_object(GLcp->source_pos); */
  
  while((ob = fl_do_forms()) != GLcp->exit);
  
  fl_finish();

  return(0);
}

void initialize()
{
  int i, j;
  
  for(i = 0; i < NG; i++) {
    root_x[i]  = 0.0;
    root_y[i]  = 0.0; 
    troot_x[i] = 0.0;
    troot_y[i] = 0.0;    
  }

  for(j = 0; j < N_params; j++) {
    x_root[j] = 0.0;
    y_root[j] = 0.0;
    x_obs[j]  = 0.0;
    y_obs[j]  = 0.0;
    mu[j]     = 0.0;
    mu_obs[j] = 0.0;
    Prmt[j]   = 0.0;
    Zero[j]   = 0.0;
    Y_x[j]    = 0.0;
    Y_y[j]    = 0.0;
    M_T[j]    = 0.0;
  }

  for(i = 0; i < N_params; i++) {
    for(j = 0; j < N_params; j++) {
      M_O[i][j] = 0.0;
    }
  }

  for(i = 0; i < 2 * N_opt; i++) {
    Xprmt[i] = parms[i];
    
    // printf("Xprmt[%d] = %g \n", i, Xprmt[i]);
  }

  srand(SEED);
}

int handle_expose(XEvent *event, void *data)
{
  FL_Coord w, h ;
  
  fl_get_winsize(GLwin, &w, &h);
  glViewport(0, 0, w, h);

  /* White Background */

  glClearColor(1.0, 1.0, 1.0, 1.0);

  /* Black Background */

  // glClearColor(0.0, 0.0, 0.0, 0.0); 
  
  glClear(GL_COLOR_BUFFER_BIT);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); 
  gluOrtho2D(- BOUND, BOUND, - BOUND_1, BOUND_1);   
  glMatrixMode(GL_MODELVIEW);  
  glLoadIdentity();   

  /* glTranslated(0.0, 0.0, fl_get_counter_value(GLcp->z_pos)); */

  glTranslated(0.0, 0.0, 0.0);  

  /* gluOrtho2D(0.0, 0.0, 4.0, 4.0); */                  

  // gluOrtho2D(- BOUND, w, - BOUND, h); 

  // gluOrtho2D(- BOUND, BOUND, - BOUND, BOUND); 

  // glMatrixMode(GL_MODELVIEW);

  if(switches & S_SOURCE) {
    draw_source(parms[P_R]);
  }
  
  if(switches & S_IMAGES) {
    draw_images();
  }
  
  if(switches & S_EINSTEIN) {
    // draw_ring(0.0, 0.0, parms[P_E]);
    
    draw_ring(0.0, 0.0, 0.0, parms[P_E]);
  }
  
  if(switches & S_RPLOT) {
    draw_rplot();
  }

  if(switches & S_GRID) {
    draw_grid();
  }
  
  if(switches & S_OBIP) {
    draw_data();
  }
  
  if(switches & S_INVERT) {
    draw_invert();
  }

  if(switches & S_CONTOUR) {
    draw_contour();
  }

  if(switches & S_TIMEDELAY) {
    draw_contour_td();
  }

  /*

  if(switches & S_ROOTS) {
    cb_root_positions();
  }

  **/

  /*

  if(switches & S_DATA) {
    draw_data();
  }

  **/

  /*

  glutKeyboardFunc(keyboard); 
  glutMouseFunc(mouse); 

  **/

  glXSwapBuffers(fl_display, GLwin);
  
  return(0);
}

void draw_source(double r)
{
  int i;
  double dr;
    
  // GLfloat color[3];

  GLUquadricObj *qobj = gluNewQuadric();

  glPushMatrix();

  /* glMatrixMode(GL_PROJECTION);
     glLoadIdentity(); */

  glTranslated(source_position.x, source_position.y, 0.0); 

  switch(source_figure) {
  case F_MODEL:

    break;
  case F_FULL_CIRCLE:
    glColor3f(1.0, 0.0, 0.0);

    /* gluQuadricDrawStyle(qobj, GLU_SILHOUETTE); */

    gluQuadricDrawStyle(qobj, GLU_FILL);

    gluDisk(qobj, 0.0, r, 32, 1);

    break;
  case F_RINGS:
    if(r <= R_MIN) {
      glColor3f(1.0, 1.0, 1.0);
      
      /* gluQuadricDrawStyle(qobj, GLU_SILHOUETTE); */

      gluQuadricDrawStyle(qobj, GLU_FILL); 
      gluDisk(qobj, 0.0, R_MIN, 32, 1);
    } else {
      dr = (r - R_MIN) / ((double) Nf);

      for(i = 0; i < Nf; ++i, r -= dr) {
	// colormap_s(r, r, color);
	// glColor3fv(color);

	/* Black */

	glColor3f(0.0, 0.0, 0.0);

	/* gluQuadricDrawStyle(qobj, GLU_SILHOUETTE); */
	
	gluQuadricDrawStyle(qobj, GLU_FILL); 
	gluDisk(qobj, 0.0, r, 32, 1);
      }
    }

    break;

    /*

  case F_CIRCLE:
    Circle(parms[P_R], One, 5);
    
    break;
  case F_CON_CIRCLE:
    Con_Circ(parms[P_R], One);
    
    break;
  case F_ELLIPSE:
    Ellipse(parms[P_R], One, 5, 45.0);
    
    break;
  case F_CON_ELLIPSE:
    Con_Ellip(parms[P_R], One, 45.0);
    
    break;
  case F_SPIRAL:
    Spiral(parms[P_R], One, 5, 45.0);
    
    break;
  case F_PATTERN:
    Pattern(parms[P_R], One, 5, 45.0);
    
    break;
  case F_RAN_PATTERN:
    Pattern2(parms[P_R], One, 5, 45.0);
    
    break;

    **/

  case F_IMAGE:
    /* fprintf(stderr, "Not yet implemented!\n"); */

    /*

      fl_set_slider_value(GLcp->p_E, 0.0); 

      parms[P_E] = 0.0;

      fl_set_choice(GLcp->choice0, 4); 
      fl_set_choice(GLcp->choice1, 2); 

      source_figure = F_IMAGE;

    **/

    /* current_model = M_CHANG_REFSDAL; */
    
    /*

      current_model = 0;

      draw_images();

    **/

    if(image_switch == FALSE) {
      printf("Please, select an image with the Image File button! \n");
    } else {
      draw_invert();
    }

    break;
  default:
    break;
  }

  glPopMatrix();
  gluDeleteQuadric(qobj);
}

/*
  
double cs = cos(parms[P_THETA]);
double ss = sin(parms[P_THETA]);
double cs = cos((M_PI * parms[P_THETA]) / 180.0);
double ss = sin((M_PI * parms[P_THETA]) / 180.0);

double x0 = BOUND;

**/

void draw_images(void)
{
  /* Local variables */

  z1 = source_position.x;
  z2 = source_position.y;

  /*

  if(source_figure == F_IMAGE) {
    draw_photo();
  } else {
    images();
  }

  **/

  switch(source_figure) {
  case F_MODEL:

    break;
  case F_FULL_CIRCLE:    
    images();

    break;
  case F_RINGS:
    images();
    
    break;
    
    /*
  
  case F_CIRCLE:
    switch(current_model) {
    case M_MODEL_MENU:
      break;
    case M_CHANG_REFSDAL:    
    case M_SING_ISOT_SPHERE:
    case M_DE_VAUCOULEUR:
    case M_KING:
    case M_HUBBLE:
    case M_SPIRAL:
    case M_TRUNC_KING:
    case M_NSING_ISOT_SPHERE:
    case M_TRANSP_SPHERE:
    case M_ELLIPTICAL:
    case M_MULTIPOLE:
    case M_ROTATION_LENS:
    case M_DOUBLE_LENS:
    case M_UNIFORM_RING:
      root_finder2(1.0, Zero, 5, 1.0);      
      break;
    default:
      break;
    }

    break;
  case F_CON_CIRCLE:
    root_finder2(1.0, Zero, 5, 1.0);      

    break;
  case F_ELLIPSE:
    root_finder2(1.0, Zero, 5, 1.0);      
    
    break;
  case F_CON_ELLIPSE:
    root_finder2(1.0, Zero, 5, 1.0);      
    
    break;
  case F_SPIRAL:
    switch(current_model) {
    case M_MODEL_MENU:
      break;
    case M_CHANG_REFSDAL:    
    case M_SING_ISOT_SPHERE:
    case M_DE_VAUCOULEUR:
    case M_KING:
    case M_HUBBLE:
    case M_SPIRAL:
    case M_TRUNC_KING:
    case M_NSING_ISOT_SPHERE:
    case M_TRANSP_SPHERE:
    case M_ELLIPTICAL:
    case M_MULTIPOLE:
    case M_ROTATION_LENS:
    case M_DOUBLE_LENS:
    case M_UNIFORM_RING:
      root_finder2(1.0, Zero, 5, 1.0);      
      break;
    default:
      break;
    }
    
    break;
  case F_PATTERN:
    root_finder2(1.0, Zero, 5, 1.0);      
    
    break;
  case F_RAN_PATTERN:
    root_finder2(1.0, Zero, 5, 1.0);      
    
    break;

    **/

  case F_IMAGE:
    if(image_switch == FALSE) {
      printf("Please, select an image with the Image File button! \n");
    } else {
      draw_photo();
    }
        
    break;
  default:
    break;
  }

  glXSwapBuffers(fl_display, GLwin);  
}

void images()
{
  double x1, x2, dist2, dp;
  double y1, y2, x1bar, x2bar;
  
  GLint w, h;  
  GLfloat color[3];

  /*
    
    double z1 = source_position.x;
    double z2 = source_position.y;
    
    double cs = cos(parms[P_THETA]);    
    double ss = sin(parms[P_THETA]);
    
    double x0 = BOUND;  
    
  **/

  z1 = source_position.x;
  z2 = source_position.y;

  /*
    
  cs = cos(parms[P_THETA]);
  ss = sin(parms[P_THETA]);

  **/

  cs = cos((M_PI * parms[P_THETA]) / 180.0);
  ss = sin((M_PI * parms[P_THETA]) / 180.0);

  fl_get_winsize(GLwin, &w, &h);

  dp = (2.0 * precision * xb0) / ((double) w);

  glPointSize(precision * M_SQRT2);

  if(switches & S_SMOOTH) {
    glEnable(GL_POINT_SMOOTH);
  } else {
    glDisable(GL_POINT_SMOOTH);
  }

  xl = 0.0;
  yl = 0.0;

  glColor3f(0.0, 0.0, 1.0);

  glBegin(GL_POINTS);
  
  for(x1 = - xb0; x1 <= xb0; x1 += dp) {      
    for(x2 = - xb0; x2 <= xb0; x2 += dp) {
      x1bar =   (x1 - xl) * cs + (x2 - yl) * ss;
      x2bar = - (x1 - xl) * ss + (x2 - yl) * cs;

      lens_equation(x1bar, x2bar, &y1, &y2);
      
      dist2 = (y1 - z1) * (y1 - z1) + (y2 - z2) * (y2 - z2);

      if(dist2 <= (parms[P_R] * parms[P_R])) {
        if(source_figure == F_RINGS) {
          colormap(y1 - z1, y2 - z2, color);
          glColor3fv(color);
        }
        
        glVertex2d(x1, x2);   
      }
    }
  }
  
  glEnd();
}  

/*

double xrote, yrote;

void rotate(double x, double y, double theta)
{
  xrote =   x * cos(theta) + y * sin(theta);
  yrote = - x * sin(theta) + y * cos(theta);
}

**/

void draw_photo(void)
{
  /* unsigned int x, y, w, h, p; */

  /* It works but by  compiling without error message */
  
  /* FL_Coord w, h; */ 
  
  int xp, yp;

  GLint w, h; 

  /* It works but by compiling with an error message */
  
  /* unsigned int w, h; */ 
  
  double x1, x2, dpx, dpy;
  double y1, y2;
  double x1bar, x2bar;
  double fx, fy;

  /*
    
  double x0 = (double) BOUND;

  double z1 = source_position.x;
  double z2 = source_position.y;

  double cs = cos(parms[P_THETA]);
  double ss = sin(parms[P_THETA]);

  **/

  z1 = source_position.x;
  z2 = source_position.y;

  /*
    
  cs = cos(parms[P_THETA]);
  ss = sin(parms[P_THETA]);

  **/
  
  cs = cos((M_PI * parms[P_THETA]) / 180.0);
  ss = sin((M_PI * parms[P_THETA]) / 180.0);

  /* im = Imlib_load_image(id, "abel2218.jpg"); */
  /* im = Imlib_load_image(id, "sp.jpg");       */
  /* im = Imlib_load_image(id, "dragon.jpeg");  */
  /* im = Imlib_load_image(id, "m45.jpg");      */
  /* im = Imlib_load_image(id, "s2.jpg");       */
  /* im = Imlib_load_image(id, "s3.jpg");       */

  im = Imlib_load_image(id, fname); 
  
  fl_get_winsize(GLwin, &w, &h);
     
  /* fl_get_winsize(GLwin, w, h); */
 
  dpx = (2.0 * xb0) / ((double) (im->rgb_width));  
  dpy = (2.0 * xb0) / ((double) (im->rgb_height)); 

  fx = 1.0 / dpx;
  fy = 1.0 / dpy;

  dpx *= precision;
  dpy *= precision;

  glPointSize((w / im->rgb_width) * M_SQRT2); 

  /* glPointSize(((unsigned int) w) / im->rgb_width * M_SQRT2); */

  if(switches & S_SMOOTH) {
    glEnable(GL_POINT_SMOOTH);
  } else {
    glDisable(GL_POINT_SMOOTH);
  }
  
  xl = 0.0;
  yl = 0.0;

  glColor3f(1.0, 1.0, 1.0);

  glBegin(GL_POINTS);

  for(x1 = - xb0; x1 <= xb0; x1 += dpx) {
    for(x2 = - xb0; x2 <= xb0; x2 += dpy) {
      x1bar =   (x1 - xl) * cs + (x2 - yl) * ss;
      x2bar = - (x1 - xl) * ss + (x2 - yl) * cs;

      lens_equation(x1bar, x2bar, &y1, &y2);

      y1 -= z1;
      y2 -= z2;

      xp = (int)((  y1 + xb0) * fx);
      yp = (int)((- y2 + xb0) * fy);
        
      if((y1 <= - xb0) || (y1 >= xb0) || (y2 <= - xb0) || (y2 >= xb0)) {
	glColor3f(0.0, 0.0, 0.0);
      } else {
        glColor3ubv(im->rgb_data + 3 * (xp + yp * (im->rgb_width))); 
      }

      glVertex2d(x1, x2);
    }
  }
  
  glEnd();

  Imlib_destroy_image(id, im); 
}

void draw_invert(void)
{
  double x1, x2, dist2, dp;
  double y1, y2;
  double x1bar, x2bar;

  GLint w, h;
  GLfloat color[3];

  if(source_figure == F_IMAGE)
    draw_photo_invert();
  else {
    /*

    double z1 = source_position.x;
    double z2 = source_position.y;

    double cs = cos(parms[P_THETA]);
    double ss = sin(parms[P_THETA]);

    double x0 = BOUND;

    **/

    z1 = source_position.x;
    z2 = source_position.y;

    /*
      
    cs = cos(parms[P_THETA]);
    ss = sin(parms[P_THETA]);

    **/
    
    cs = cos((M_PI * parms[P_THETA]) / 180.0);
    ss = sin((M_PI * parms[P_THETA]) / 180.0);

    fl_get_winsize(GLwin, &w, &h);

    dp = (2.0 * precision * xb0) / ((double) w);

    glPointSize(precision * M_SQRT2);

    if(switches & S_SMOOTH) {
      glEnable(GL_POINT_SMOOTH);
    } else {
      glDisable(GL_POINT_SMOOTH);
    }

    xl = 0.0;
    yl = 0.0;
    
    glColor3f(0.0, 0.0, 1.0);

    glBegin(GL_POINTS);

    for(x1 = - xb0; x1 <= xb0; x1 += dp) {
      for(x2 = - xb0; x2 <= xb0; x2 += dp) {
        x1bar =   (x1 - xl) * cs + (x2 - yl) * ss;
        x2bar = - (x1 - xl) * ss + (x2 - yl) * cs;
	
	lens_equation(x1bar, x2bar, &y1, &y2);
      
	dist2 = (x1 - z1) * (x1 - z1) + (x2 - z2) * (x2 - z2);

	if(dist2 <= (parms[P_R] * parms[P_R])) {
	  if(source_figure == F_RINGS) {
	    colormap(x1 - z1, x2 - z2, color);
	    glColor3fv(color);
	  }

          glVertex2d(x1, x2);
        } 
      }
    }
    
    glEnd();
  }
}

void draw_photo_invert(void)
{
  /* unsigned int x, y, w, h, p; */

  /* It works, by compiling without error message */  

  /* FL_Coord w, h; */ 

  int xp, yp;

  GLint w, h; 

  /* It works but by compiling with an error message */
  
  /* unsigned int w, h; */ 
  
  double x1, x2, x1bar, x2bar;
  double y1, y2;
  double dpx, dpy;
  double fx, fy;
  
  /*
    
  double x0 = (double) BOUND;

  double z1 = source_position.x;
  double z2 = source_position.y;

  double cs = cos(parms[P_THETA]);
  double ss = sin(parms[P_THETA]);

  **/

  z1 = source_position.x;
  z2 = source_position.y;

  /*
    
  cs = cos(parms[P_THETA]);
  ss = sin(parms[P_THETA]);

  **/
  
  cs = cos((M_PI * parms[P_THETA]) / 180.0);
  ss = sin((M_PI * parms[P_THETA]) / 180.0);

  /* im = Imlib_load_image(id, "abel2218.jpg"); */
  /* im = Imlib_load_image(id, "sp.jpg");       */
  /* im = Imlib_load_image(id, "dragon.jpeg");  */
  /* im = Imlib_load_image(id, "m45.jpg");      */
  /* im = Imlib_load_image(id, "s2.jpg");       */
  /* im = Imlib_load_image(id, "s3.jpg");       */

  im = Imlib_load_image(id, fname); 
 
  fl_get_winsize(GLwin, &w, &h);
     
  /* fl_get_winsize(GLwin, w, h); */
 
  dpx = (2.0 * xb0) / ((double) (im->rgb_width));  
  dpy = (2.0 * xb0) / ((double) (im->rgb_height)); 

  fx = 1.0 / dpx;
  fy = 1.0 / dpy;

  dpx *= precision;
  dpy *= precision;

  glPointSize((w / im->rgb_width) * M_SQRT2); 

  /* glPointSize(((unsigned int) w) / im->rgb_width * M_SQRT2); */
    
  if(switches & S_SMOOTH) {
    glEnable(GL_POINT_SMOOTH);
  } else {
    glDisable(GL_POINT_SMOOTH);
  }
  
  xl = 0.0;
  yl = 0.0;
  
  glColor3f(1.0, 1.0, 1.0);  

  glBegin(GL_POINTS);

  for(x1 = - xb0; x1 <= xb0; x1 += dpx) {
    for(x2 = - xb0; x2 <= xb0; x2 += dpy) {
      x1bar =   (x1 - xl) * cs + (x2 - yl) * ss;
      x2bar = - (x1 - xl) * ss + (x2 - yl) * cs;

      lens_equation(x1bar, x2bar, &y1, &y2);

      y1 -= z1;
      y2 -= z2;

      xp = (int)((x1 + xb0) * fx);
      yp = (int)((- x2 + xb0) * fy);

      if((y1 <= - xb0) || (y1 >= xb0) || (y2 <= - xb0) || (y2 >= xb0)) {
	glColor3f(0.0, 0.0, 0.0);
      } else {	
        glColor3ubv(im->rgb_data + 3 * (xp + yp * (im->rgb_width))); 
      }

      glVertex2d(x1, x2);
    }
  }

  glEnd();

  Imlib_destroy_image(id, im); 
}

void draw_ring(double x, double y, double radi, double rado)
{
  GLUquadricObj *qobj = gluNewQuadric();
  
  /* glMatrixMode(GL_PROJECTION);
     glLoadIdentity(); */

  glColor3f(0.0, 1.0, 0.0);
  gluQuadricDrawStyle(qobj, GLU_SILHOUETTE);
  glPushMatrix();
  glTranslated(x, y, 0.0); 
  gluDisk(qobj, radi, rado, 32, 1);
  glPopMatrix();
  gluDeleteQuadric(qobj);
}

void draw_rplot(void)
{
  GLint w, h;
  double x1, x2, y1, y2, x1bar, x2bar, ds;   
  
  /*
    
  double x0 = (double) BOUND;

  double z1 = source_position.x;
  double z2 = source_position.y;

  double cs = cos(parms[P_THETA]);
  double ss = sin(parms[P_THETA]);

  **/

  /*
    
  z1 = source_position.x;
  z2 = source_position.y;

  **/

  /* To move the Ray Plot, change this */
  
  z1 = 0.0;
  z2 = 0.0;
  
  /*
    
  cs = cos(parms[P_THETA]);
  ss = sin(parms[P_THETA]);

  **/
  
  cs = cos((M_PI * parms[P_THETA]) / 180.0);
  ss = sin((M_PI * parms[P_THETA]) / 180.0);

  fl_get_winsize(GLwin, &w, &h);
   
  /* ds = 2.0 * precision * BOUND / (double)w; */

  ds = (4.0 * precision * xb0) / ((double) w); 
  
  // glPointSize(precision * M_SQRT2);

  glPointSize(One);

  if(switches & S_SMOOTH) {
    glEnable(GL_POINT_SMOOTH);
  } else {
    glDisable(GL_POINT_SMOOTH);
  }

  xl = 0.0;
  yl = 0.0;

  /* Blue */

  // glColor3f(0.0, 0.0, 1.0);
  
  /* Magenta */ 

  glColor3f(1.0, 0.0, 1.0);

  glBegin(GL_POINTS);

  for(x1 = - xb0; x1 <= xb0; x1 += ds) {
    for(x2 = - xb0; x2 <= xb0; x2 += ds) {
      x1bar =   (x1 - xl) * cs + (x2 - yl) * ss;
      x2bar = - (x1 - xl) * ss + (x2 - yl) * cs;
      
      lens_equation(x1bar, x2bar, &y1, &y2);
      
      glVertex2d(y1 - z1, y2 - z2);
    }
  }  

  glEnd();  

  /*

  Circle(parms[P_E], One, 2);
  Ellipse(parms[P_E], One, 2, 45.0);
  Spiral(parms[P_E], One, 2, 45.0);
  Con_Circ(parms[P_E], One);
  Con_Ellip(parms[P_E], One, 45.0);
  Pattern(parms[P_E], One, 2, 45.0);
  Pattern2(parms[P_E], One, 2, 45.0);

  **/
}

void draw_grid(void)
{
  //  GLint w, h;
  
  double x_i;

  // fl_get_winsize(GLwin, &w, &h);

  /* Red */

  glColor3d(1.0, 0.0, 0.0);

  /*

  glBegin(GL_LINES);
  
  for(x_i = - xb0; x_i <= xb0; x_i += xb0 / 25.0) {
    glVertex2f(x_i, - xb0);
    glVertex2f(x_i,   xb0);
  }
  
  for(x_i = - xb0; x_i <= xb0; x_i += xb0 / 25.0) {
    glVertex2f(- xb0, x_i);
    glVertex2f(  xb0, x_i);
  }

  */


  glBegin(GL_LINES);
  
  for(x_i = - xb0; x_i <= xb0; x_i += xb0 / 5.0) {
    glVertex2f(x_i, - xb0);
    glVertex2f(x_i, - (21.5 * xb0) / 25.0);
  }
  
  for(x_i = - xb0; x_i <= xb0; x_i += xb0 / 5.0) {
    glVertex2f(- xb0, x_i);
    glVertex2f(- (24.0 * xb0) / 25.0, x_i);
  }

  /* White */

  // glColor3d(1.0, 1.0, 1.0);

  glColor3d(0.0, 0.0, 0.0);

  glVertex2f(0.0, - xb0);
  glVertex2f(0.0,   xb0);
  glVertex2f(- xb0, 0.0);
  glVertex2f(  xb0, 0.0);  

  glEnd();
}

/* 

void draw_data(void)
{
  GLUquadricObj *qobj = gluNewQuadric();
  int n, i;
  char s1[9], s2[9];
  double x, y; 
  
  glColor3f(0.0, 0.0, 1.0);
  gluQuadricDrawStyle(qobj, GLU_SILHOUETTE);
  
  n = fl_get_browser_maxline(GLcp->image_locations);
  
  for(i=1; i <= n; ++i) {
    sscanf(fl_get_browser_line(GLcp->image_locations, i),
	   "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);
    
    x = strtod(s1, NULL);
    y = strtod(s2, NULL);
    
    glPushMatrix();
    glTranslated(x, y, 0.0);    
    gluDisk(qobj, 0.20, 0.40, 32, 5);
    glPopMatrix();
  }

  gluDeleteQuadric(qobj);
} 

**/

void draw_data(void)
{
  int n, i;
  char s1[9], s2[9];
  double x, y; 

  /* n = fl_get_browser_maxline(GLcp->image_locations); */
  
  n = fl_get_browser_maxline(Oposition->image_locations);

  for(i=1; i <= n; ++i) {

    /* sscanf(fl_get_browser_line(GLcp->image_locations, i),
              "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2); */

    sscanf(fl_get_browser_line(Oposition->image_locations, i),
	   "%8[0123456789.-+]; %8[0123456789.-+]", s1, s2);
    
    x = strtod(s1, NULL);
    y = strtod(s2, NULL);
    
    draw_ring(x, y, 0.10, 0.30);     
    draw_ring(x, y, 0.20, 0.40);     
  }

  /* handle_expose(0, 0); */
}

void colormap(float x, float y, GLfloat *color)
{
  color[0] = 0.0;
  color[1] = 0.0;
  color[2] = 1.0 - 0.75 * (x * x + y * y) / (parms[P_R] * parms[P_R]);
}

void colormap_s(float x, float y, GLfloat *color)
{
  color[0] = 1.0 - 0.75 * (x * x + y * y) / (parms[P_R] * parms[P_R]);
  color[1] = 0.0;
  color[2] = 0.0;
}

void draw_circle(double x, double y, double rad)
{
  GLUquadricObj *qobjn = gluNewQuadric();

  glColor3f(0.0, 1.0, 0.0);   
  gluQuadricDrawStyle(qobjn, GLU_SILHOUETTE);
  
  glPushMatrix();       
  glTranslated(x, y, 0.0);  
  gluDisk(qobjn, 0.0, rad, 32, 1);      
  glPopMatrix();        
  gluDeleteQuadric(qobjn);      
  
  /* glXSwapBuffers(fl_display, GLwin); */     
}

void draw_point(double x, double y, double rad, int color)
{
  /* Set the modelview matrix to be the identity matrix */

  /* glLoadIdentity(); */

  /* Translate the object */

  /* glTranslatef(x, y, 0.0); */
  
  /* Set the color */       

  // glColor3f(1.0, 1.0, 1.0);

  color_point(color);

  /* Set the point size */
  
  glPointSize(rad);

  /* Draw filtered points */

  glEnable(GL_POINT_SMOOTH);

  glBegin(GL_POINTS);
  glVertex2d(x, y);
  glEnd();

  /* Flush the buffer to force drawing of all objects thus far */

  glFlush();

  //  glPopMatrix();
}

void Circle(float r, float Size, int color)
{
  double y1, y2, phi, dphi = 0.01, Npi = 2.0 * M_PI;
  double dxi = 1.0, dxf, xf = BOUND, dyf;
  int ir = 0;

  VEC x_init;

  // r = parms[P_E];
  
  z1 = source_position.x;
  z2 = source_position.y;

  glPointSize(Size);

  color_point(color);

  glBegin(GL_POINTS);

  for(phi = 0; phi < Npi; phi = phi + dphi) { 
    y1 = r * cos(phi);
    y2 = r * sin(phi);
    
    glVertex2d(y1, y2);    

    pars[0] = y1 + z1;     
    pars[1] = y2 + z2; 

    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      for(dyf = - xf; dyf <= xf; dyf += dxi) {    
	x_init[0] = dxf; 
	x_init[1] = dyf;
	
	roots4(x_init, ir, color, 2, pars);        
	
	ir += 1;
      }     
    }  
  }
  
  glEnd();
}

void Con_Circ(float r, float Size)
{
  int j, l = 0, N_c = 5;
  double rad_c = r, dr_c = r / 10.0, phi_c;
  double dphi = M_PI / 100.0, Npi = 2.0 * M_PI, y1, y2;

  glPointSize(Size);

  for(j = 0; j < N_c; j++) {
    color_point(j);
    
    for(phi_c = 0; phi_c < Npi; phi_c += dphi) {
      y1 = rad_c * cos(phi_c);
      y2 = rad_c * sin(phi_c);

      glBegin(GL_POINTS);
      glVertex2d(y1, y2);
      glEnd();

      l += 1;
    }

    rad_c += dr_c; 
  }
}

void Ellipse(float r, float Size, int color, float angle)
{
  double a, b, phi, y1, y2, y1bar, y2bar, dr, Npi = 2.0 * M_PI, co, so;

  dr = r / 5.0;

  a = r + dr; 
  b = r - dr; 
  
  co = cos((M_PI * angle) / 180.0);
  so = sin((M_PI * angle) / 180.0);

  color_point(color);

  glPointSize(Size);

  glBegin(GL_POINTS);
    
  for(phi = 0; phi < Npi; phi = phi + 0.01) {
    y1 = a * cos(phi);
    y2 = b * sin(phi);

    y1bar =   y1 * co + y2 * so;
    y2bar = - y1 * so + y2 * co;

    glVertex2d(y1bar, y2bar);
  }

  glEnd();
}

void Con_Ellip(float r, float Size, float angle)
{
  int j, l = 0, N_c = 5;
  double a_e, b_e, dr_c = r / 10.0, phi_e, co, so, y1, y2, y1bar, y2bar;
  double dphi = M_PI / 100.0, Npi = 2.0 * M_PI;

  co = cos((M_PI * angle) / 180.0);
  so = sin((M_PI * angle) / 180.0);

  a_e = r + dr_c;
  b_e = r - dr_c;

  glPointSize(Size);

  for(j = 0; j < N_c; j++) {
    color_point(j);

    for(phi_e = 0; phi_e < Npi; phi_e += dphi) {
      y1 = a_e * cos(phi_e);
      y2 = b_e * sin(phi_e);

      y1bar =   y1 * co + y2 * so;
      y2bar = - y1 * so + y2 * co;

      glBegin(GL_POINTS);
      glVertex2d(y1bar, y2bar);
      glEnd();

      l += 1;
    }

    a_e += dr_c;
    b_e += dr_c;
  }
}

void Pattern(float r, float Size, int color, float angle)
{
  double k1, k2, ct10, ct20, y1bar, y2bar, co, so;

  co = cos((M_PI * angle) / 180.0);
  so = sin((M_PI * angle) / 180.0);

  color_point(color);

  glPointSize(Size);

  ct10 = r / 10.0;
  ct20 = r / 10.0;

  glBegin(GL_POINTS);
      
  for(k1 = - r; k1 <= r; k1 += ct10) {
    for(k2 = - r; k2 <= r; k2 += ct20) {
      y1bar =   k1 * co + k2 * so;
      y2bar = - k1 * so + k2 * co;

      glVertex2d(y1bar, y2bar);
    }
  }
  
  glEnd();
}

void Pattern2(float r, float Size, int color, float angle)
{
  int n, m, Npat1 = 50, Npat2 = 50;
  double k1, k2, ct10, ct20, y1, y2, y1bar, y2bar, co, so;

  co = cos((M_PI * angle) / 180.0);
  so = sin((M_PI * angle) / 180.0);

  color_point(color);
  
  glPointSize(Size);

  k1 = - r;
  k2 = - r;

  ct10 = r / 10.0;
  ct20 = r / 10.0;

  glBegin(GL_POINTS);

  for(n = 0; n < Npat1; n++) {
    for(m = 0; m < Npat2; m++) {
      y1 = k1 + ct10 * hrand(n, m);
      y2 = k2 + ct20 * hrand(n, m);

      y1bar =   y1 * co + y2 * so;
      y2bar = - y1 * so + y2 * co;

      glVertex2d(y1bar, y2bar);
    }
  }

  glEnd();
}

void Spiral(float r, float Size, int color, float angle)
{
  int l, Ndib = Num;
  double rad_sp, phi_sp, y1, y2, y1bar, y2bar, co, so;
  double ct0 = 4.0, ctm = r / 25.0;

  co = cos((M_PI * angle) / 180.0);
  so = sin((M_PI * angle) / 180.0);

  color_point(color);

  glPointSize(Size);

  glBegin(GL_POINTS);
  
  for(l = 0; l < Ndib; l++) {
    phi_sp = ((ct0 * Pi * ((double) l))) / Ndib;
    rad_sp = ctm * phi_sp;

    y1 = rad_sp * cos(phi_sp);
    y2 = rad_sp * sin(phi_sp);

    y1bar =   y1 * co + y2 * so;
    y2bar = - y1 * so + y2 * co;
    
    glVertex2d(y1bar, y2bar);
  }
  
  glEnd();
}

void color_point(int i)
{
  switch(i) { 
  case 0:
    /* Red */ 
    
    glColor3f(1.0, 0.0, 0.0);
    break;
  case 1:
    /* Green */ 

    glColor3f(0.0, 1.0, 0.0);
    break;
  case 2:
    /* Blue */ 

    glColor3f(0.0, 0.0, 1.0);
    break;
  case 3:
    /* Yellow */ 

    glColor3f(1.0, 1.0, 0.0);
    break;
  case 4:
    /* White */ 

    glColor3f(1.0, 1.0, 1.0);
    break;
  case 5:
    /* Cyan */ 

    glColor3f(0.0, 1.0, 1.0);
    break;
  case 6:
    /* Magenta */ 

    glColor3f(1.0, 0.0, 1.0);
    break;
  case 7:
    /* Black */ 

    glColor3f(0.0, 0.0, 0.0);
    break;    
  }
}

float hrand(float low, float high)
{
  float value;

  value = ((float) ((short)rand() & 0xffff)) / ((float) 0xffff);

  return((2.0 * value * (high - low)) + low);
}

